


;               HCC FIG generic 8086 FORTH
; $Id: fig86.gnr,v 2.148 2000/12/02 14:58:07 albert Exp $
; Copyright (2000): Albert van der Horst, HCC FIG Holland by GNU Public License
;
        ;  66,106
 ;   GENERIC FORTH FOR 8086 $Revision: 2.148 $
 ;
; NASM version of FIG FORTH created by M4 from generic listing.
;
%if 0
        A generic version of FIG-FORTH for IBM type standard PC's
                Albert van der Horst
                HCC Forth user group
                The Netherlands
                www.forth.hccnet.nl

              based on
              FIG-FORTH
   implemented by:  Charlie Krajewski
                    205 ( BIG ) Blue Rd.
                    Middletown, CT  06457

  This implementation supports only one 64k segment

  The listing has been made possible by the
  prior work of:
               Thomas Newman, Hayward, Ca.

 : other_acknowledgements
         John_Cassidy
         Kim_Harris
         George_Flammer
         Robert_D._Villwock ;
 To upgrade, modify, and understand Fig Forth, the
 value of the following book cannot be overstated:
         Systems Guide to FIG Forth
         C. H. Ting, PhD
 It is available through MVP.  See any recent issue
 of FORTH Dimensions for their ad. (DIXIT AD MDCCCCLXXX)

No one who programs with FORTH can afford to be without:
  Starting Forth
  Leo Brodie
Get it.  Available through FORTH Interest Group.
Can also be found in many book stores.
Chapter 3 serves as a guide for the EDITOR that you
will probably type in from the FIG-Forth installation
manual.

Although there is much to be said for typing in your own
listing and getting it running, there is much to be said
not typing in your own listing.  If you feel that 100+
pages of plinking is nutty, contact me for availability
of a disc with source & executable files.  Obtainable at
a bargain basement price, prepare yourself for bargain
basement support.

All publications of the FORTH Interest Group are public domain.
They may be further distributed by the inclusion of this
credit notice:
               This publication has been made available by:

               FORTH Interest Group
               P.O. Box 1105
               San Carlos, Ca.  94070
%endif
        ;
; ########################################################################################
;                       PREPARATION (no code)
; ########################################################################################
FIGREL  EQU     2       ; FIG RELEASE #
FIGREV  EQU     0       ; FIG REVISION #
USRVER  EQU     34      ; USER VERSION NUMBER, a digit now
;
;       PROTECTION
CW      EQU     2       ; I.e. for the mode used in Forth, not in the bootcode.
PMASK   EQU     0FFH    ; Allow to access only 256 blocks from OFFSET
;
;      ASCII CHARACTER EQUIVALENTS
;
ABL     EQU     20H     ; SPACE
ACR     EQU     0DH     ; CR
ADOT    EQU     2EH     ; PERIOD
BELL    EQU     07H     ; ^G
BSIN    EQU     08H     ; INPUT DELETE CHARACTER
BSOUT   EQU     08H     ; OUTPUT BACKSPACE ( ^H )
LF      EQU     0AH     ; LINE FEED, USED INTERNALLY AS
                        ; LINE ENDER
FF      EQU     0CH     ; FORM FEED
;
;      MEMORY + I/O CONSTANTS
;
NBUF    EQU     2       ; NO. OF BUFFERS AKA SCREENS 
KBBUF   EQU     1024    ;DATA BYTES PER DISK BUFFER
US      EQU     100H     ; USER VARIABLE SPACE
 RTS     EQU     0A0H    ; RETURN STACK & TERM BUFFER 

;

EM      EQU     10000H   ; END OF MEMORY + 1

BUF1    EQU     EM-(KBBUF+2*2)*NBUF      ; FIRST DISK BUFFER
STRUSA  EQU     BUF1-US         ; User area
 ;
;

STRTIB  EQU     STRUSA-RTS      ; Start return stack area
                                ; Under this : data stack
INITR0  EQU     STRUSA         ; Grows down
INITS0  EQU     STRTIB          ; Growns down
 ;

;

BPS     EQU     512             ;Bytes/sector, common to all of MSDOS
SPB     EQU     KBBUF/BPS
;
; PHYSICAL DISK PARAMETERS
; (not needed for MODERN)
; (not needed for BOOTHD)
;
; Disk parameters: 
; HD drive 3" 
TRKS    EQU     80    ;Number of tracks
SPT     EQU     18    ;Sectors/track
HEADS   EQU     2     ;Number of heads 
NFAT    EQU     2     ; Number of FATS
SECROOT EQU     0EH   ; Sectors for root directory entry.
SECFAT  EQU     9     ; Sectors per FAT
MEDIA   EQU    0F0H   ; Descriptor byte. Anachronism.

%if 0
; HD drive 5" 
TRKS    EQU     80      ;Number of tracks
SPT     EQU     15      ;Sectors/track
HEADS   EQU     2       ;Number of heads 
NFAT    EQU     2       ; Number of FATS
SECROOT EQU     ?       ; Sectors for root directory entry.
SECFAT  EQU     ?       ; Sectors per FAT
MEDIA   EQU    F0H      ; Descriptor byte. Anachronism.
%endif

; Bios specific equates.
BOOTADDRESS     EQU     07C00H ; PC jumps to 0:7C00 to boot
SPDRV   EQU     HEADS*TRKS*SPT    ; sectors/drive
        ; Skip boot sector,fats and root dir and first sector of file.
SECSTRT EQU     1+NFAT*SECFAT + SECROOT + 1
%if 0
; Alternative if the disk need not be recognized by MSDOS
; Usable for generating a bootable floppy simple.
SECSTRT EQU     1
%endif
; END  OF PHYSICAL DISK PARAMETERS

;

;

;

        ;
; ########################################################################################
;                      BOOTCODE    (optional, always real mode)
; ########################################################################################

; All bootcode must be relocatable and its memory references absolute.
; Not for the sake of booting, but to allow MSDOS to start the program too. 

        ;    SEGMENT PARA PUBLIC 'CODE'
        ; CS:;,DS:;,SS:;,ES:;
    
ORG0:

;

;

ELSE3:
;

;

;

ENDBOOT:

; ########################################################################################
;                       ADJUST CODE SEGMENT REGISTER (still real mode)
; ########################################################################################
; Required start of .COM program.
    ORG     100H
ORIG:                         ; Accommodate also .exe files   

; ########################################################################################
;                       MOVE CODE TO ITS PLACE (still real mode)
; ########################################################################################

;

; ########################################################################################
;                       FILL GDT AND SWITCH TO PROTECTED MODE/32 BITS (optional)
; ########################################################################################
;

;

;


;************************

;************************
; The following had to wait until width32.m4 had been included.
BMASK   EQU     8000H

;

; ########################################################################################
;                       FORTH GLUE CODE (optional, except for the jump)
; ########################################################################################

;

;

;

        JMP     BOOTUP                  ; Cold start

; ########################################################################################
;                       FORTH ITSELF (entry point : BOOTUP)
; ########################################################################################
;
%if 0
   FORTH REGISTERS

   FORTH   8088     FORTH PRESERVATION RULES
   -----   ----     ----- ------------ -----
    IP      SI      Interpreter pointer.  Must be preserved
                    across FORTH words.

     W      BX      Working register.  When entering a word
                    via its code field the CFA is passed in BX.

    SP      SP      Parameter stack pointer.  Must be preserved
                    across FORTH words.

    RP      BP      Return stack.  Must be preserved across
                    FORTH words.

            AX      General register.  Used to pass data from
                    FORTH words, see label APUSH.

            DX      General register.  Used to pass more data from
                    FORTH words, see label DPUSH.

            BX      General purpose register.

            CX      General purpose register.

            CS      Segment register.  Must be preserved
                    across FORTH words.

            DS      ditto

            SS      ibid

            ES      Temporary segment register only used by
                    a few words. However it MUST remain equal to
                    DS, such that string primitives can be used
                    with impunity.

----------------------------------------------------------
%endif
        ;
%if 0
---------------------------------------------

   COMMENT CONVENTIONS
   ------- -----------

   =       IS EQUAL TO
   <-      ASSIGNMENT

  NAME        =  Address of name
  (NAME)      =  Contents of name
  ((NAME))    =  Indirect contents

  CFA         =  Address of CODE FIELD
  LFA         =  Address of LINK FIELD
  NFA         =  Address of NAME FIELD
  PFA         =  Address of PARAMETER FIELD

  S1          =  Parameter stack - 1st word
  S2          =  Parameter stack - 2nd word
  R1          =  Return stack    - 1st word
  R2          =  Return stack    - 2nd word

  LSB         =  Least significant bit
  MSB         =  Most  significant bit
  LB          =  Low byte
  HB          =  High byte
  LW          =  Low  word

------------------------------------------------------------
%endif
;
        ;
;

DPUSH:  PUSH    DX
APUSH:  PUSH    AX

;

; In 32 bit versions there may be no jumps to NEXT at all 
; The label NEXT1 is rarely relevant (for _OLDDEBUG_) 
NEXT:   LODSW           ;AX <- (IP)
NEXT1:  MOV     BX,AX   ; (W) <- (IP)

        JMP      WORD[BX]    ; TO `CFA'
        ;
;
;       Dictionary starts here.

DP0:
;  *********** 
;  *   LIT   *
;  *********** 
;  
N_LIT:     DB   80H+3
         DB      "LI"
         DB     "T"+80H
         DW    0
LIT:      DW     $+CW
                           
        LODSW           ; AX <- LITERAL
        JMP     APUSH          ; TO TOP OF STACK
;

;  *************** 
;  *   EXECUTE   *
;  *************** 
;  
N_EXEC:     DB   80H+7
         DB      "EXECUT"
         DB     "E"+80H
         DW    N_LIT
EXEC:      DW     $+CW
                           
        POP     BX      ; GET CFA
        JMP      WORD[BX]
;

;  ************** 
;  *   BRANCH   *
;  ************** 
;  
N_BRAN:     DB   80H+6
         DB      "BRANC"
         DB     "H"+80H
         DW    N_EXEC
BRAN:      DW     $+CW
                           
BRAN1:  ADD     SI,[SI]
        JMP     NEXT    ; JUMP TO OFFSET
;

;  *************** 
;  *   0BRANCH   *
;  *************** 
;  
N_ZBRAN:     DB   80H+7
         DB      "0BRANC"
         DB     "H"+80H
         DW    N_BRAN
ZBRAN:      DW     $+CW
                           
        POP     AX      ; GET STACK VALUE
        OR      AX,AX   ; ZERO?
        JZ      BRAN1   ; YES, BRANCH
        LEA     SI,[SI+(CW*1)]
        JMP     NEXT
;

;  ************ 
;  *   NOOP   *
;  ************ 
;  
N_NOOP:     DB   80H+4
         DB      "NOO"
         DB     "P"+80H
         DW    N_ZBRAN
NOOP:      DW     $+4
                           
;      DEBUG STUFF
NOP0:   DW      $+(CW*1)
        JMP SHORT     NEXT
NOP1:   DW      $+(CW*1)
        JMP SHORT     NEXT
NOP2:   DW      $+(CW*1)
        JMP SHORT     NEXT
;

;  ************** 
;  *   (LOOP)   *
;  ************** 
;  
N_XLOOP:     DB   80H+6
         DB      "(LOOP"
         DB     ")"+80H
         DW    N_NOOP
XLOOP:      DW     $+CW
                           
        MOV     BX,1    ; INCREMENT
XLOO1:  ADD     [BP],BX ; INDEX = INDEX + INCR
        MOV     AX,[BP] ; GET NEW INDEX
        SUB     AX,[BP+(CW*1)]        ; COMPARE WITH LIMIT
        XOR     AX,BX   ; TEST SIGN
        JS      BRAN1   ; KEEP LOOPING
;
;  END OF `DO' LOOP
        ADD     BP,BYTE (CW*2)  ; ADJ RETURN STACK
        LEA     SI,[SI+(CW*1)]       ; BYPASS BRANCH OFFSET
        JMP     NEXT
;

;  *************** 
;  *   (+LOOP)   *
;  *************** 
;  
N_XPLOO:     DB   80H+7
         DB      "(+LOOP"
         DB     ")"+80H
         DW    N_XLOOP
XPLOO:      DW     $+CW
                           
        POP     BX      ; GET LOOP VALUE
        JMP SHORT     XLOO1
;

;  ************ 
;  *   (DO)   *
;  ************ 
;  
N_XDO:     DB   80H+4
         DB      "(DO"
         DB     ")"+80H
         DW    N_XPLOO
XDO:      DW     $+CW
                           
        POP     DX      ; INITIAL INDEX VALUE
        POP     AX      ; LIMIT VALUE
        XCHG    BP,SP   ; GET RETURN STACK
        PUSH    AX
        PUSH    DX
        XCHG    BP,SP   ; GET PARAMETER STACK
        JMP     NEXT
;

;  ********* 
;  *   I   *
;  ********* 
;  
N_IDO:     DB   80H+1
         DB     "I"+80H
         DW    N_XDO
IDO:      DW     $+CW
                           
        MOV     AX,[BP] ; GET INDEX VALUE
        JMP     APUSH          ; TO PARAMETER STACK
;

;  *************** 
;  *   +ORIGIN   *
;  *************** 
;  
N_PORIG:     DB   80H+7
         DB      "+ORIGI"
         DB     "N"+80H
         DW    N_IDO
PORIG:      DW     DOCOL
                           
        DW      LIT
        DW      USINI
        DW      PLUS
        DW      SEMIS
;
;
;      Initialisation block for user variables through VOC-LINK
;       <<<<< must be in same order as user variables >>>>>
;
BOOTUP:
        NOP                    ; Fills jump to 4 bytes (for 16 bits code)
        
        
        JMP     LCLD     ;VECTOR TO COLD START
        NOP                    ; Fills jump to 4 bytes (for 16 bits code)
        
        
        JMP     WRM     ; VECTOR TO WARM START
        DB      FIGREL  ; FIG RELEASE #
        DB      FIGREV  ; FIG REVISION #
        DB      USRVER  ; USER REVISION #
        DB      0EH     ; VERSION ATTRIBUTES
        
USINI:
        DW      N_TASK ; FIRST DEFINITION 0 
        DW      STRUSA  ; INIT (U0) USER AREA POINTER 1
        DW      BSIN    ; RUBOUT: get rid of latest char 2
        DW      INITS0  ; INIT (S0)         3
        DW      INITR0  ; INIT (R0)         4
        DW      STRTIB  ; INIT (TIB)        5
        DW      32      ; INIT (WIDTH)      6
        DW      0       ; INIT (WARNING)      7
        DW      INITDP  ;      INIT (FENCE)  8
        DW      INITDP  ;      INIT (DP)     9
        DW      FORTH+2+(CW*2)+(CW*1) ;       INIT (VOC-LINK) 10
;
;

        DW      0       ; INIT (OFFSET) 
;
;
;
;
;
;
;      The following is the CPU's name, printed
;       during cold start.
;       The name is 32 bits in base 36.
;
;
;

CPUNM:  DW      5H,0B328H       ; '8088'     12 13 
 ;
;
;      <<<<< end of data used by cold start >>>>>
        RESB    US-($ - USINI)        ; All user can be initialised.
;

;  ************* 
;  *   DIGIT   *
;  ************* 
;  
N_DIGIT:     DB   80H+5
         DB      "DIGI"
         DB     "T"+80H
         DW    N_PORIG
DIGIT:      DW     $+CW
                           
        POP     DX      ;NUMBER BASE
        POP     AX      ;ASCII DIGIT
        SUB     AL,'0'
        JB      DIGI2   ;NUMBER ERROR
        CMP     AL,9
        JBE     DIGI1   ;NUMBER = 0 THRU 9
        SUB     AL,7
        CMP     AL,10   ;NUMBER 'A' THRU 'Z'?
        JB      DIGI2   ;NO
DIGI1:  CMP     AL,DL   ; COMPARE NUMBER TO BASE
        JAE     DIGI2   ;NUMBER ERROR
        SUB     DX,DX   ;ZERO
        MOV     DL,AL   ;NEW BINARY NUMBER
        MOV     AL,1    ;TRUE FLAG
        JMP     DPUSH          ;ADD TO STACK
;   NUMBER ERROR
DIGI2:  SUB     AX,AX   ;FALSE FLAG
        JMP     APUSH
        ;

;  ************** 
;  *   (FIND)   *
;  ************** 
;  
N_PFIND:     DB   80H+6
         DB      "(FIND"
         DB     ")"+80H
         DW    N_DIGIT
PFIND:      DW     $+CW
                           
;       MOV     AX,DS
;       MOV    ES,AX   ;ES = DS
        POP     BX      ;NFA
        POP     CX      ;STRING ADDR
;
;  SEARCH LOOP
PFIN1:  MOV     DI,CX   ;GET ADDR
        MOV     AL,[BX] ;GET WORD LENGTH
        MOV     DL,AL   ;SAVE WORD LENGTH
        XOR     AL,[DI]
        AND     AL,3FH  ;CHECK LENGTHS
        JNZ     PFIN5   ;LENGTHS DIFFER

;
;   LENGTHS MATCH - CHECK EACH CHARACTER IN NAME
PFIN2:  INC     BX
        INC     DI      ; NEXT CHAR OF NAME
        MOV     AL,[BX]
        XOR     AL,[DI] ;COMPARE NAMES
        ADD     AL,AL   ;THIS WILL BE TEST BIT 8
        JNZ     PFIN5A  ;NO MATCH
        TEST    BYTE [BX],080H;Last char of NFA?.
        JZ      PFIN2   
;
;   FOUND END OF NAME (BIT 8 SET) - A MATCH
        ADD     BX,BYTE 1+(CW*2); BX = PFA
        PUSH    BX      ; (S3) <- PFA
        MOV     AX,1    ;TRUE VALUE
        SUB     DH,DH
        JMP     DPUSH
;
;   NO NAME MATCH - TRY ANOTHER
;
; GET NEXT LINK FIELD ADDR (LFA)
; ( ZERO = FIRST WORD OF DICTIONARY )
;
PFIN5:  INC     BX      ;NEXT ADDR
        JB      PFIN6   ;END OF NAME
PFIN5A: MOV     AL,[BX] ;GET NEXT CHAR
        ADD     AL,AL   ;SET/RESET CARRY
        JMP SHORT     PFIN5   ;LOOP UNTIL FOUND
;
PFIN6:  MOV     BX,[BX] ; GET LINK FIELD ADDR
        OR      BX,BX   ; START OF DICT ( 0 )
        JNZ     PFIN1   ; NO , LOOK MORE
        MOV     AX,0    ; FALSE FLAG
        JMP     APUSH          ; DONE ( NO MATCH FOUND )
;

;  *************** 
;  *   ENCLOSE   *
;  *************** 
;  
N_ENCL:     DB   80H+7
         DB      "ENCLOS"
         DB     "E"+80H
         DW    N_PFIND
ENCL:      DW     $+CW
                           
        POP     AX      ;S1 - TERMINATOR CHAR
        POP     BX      ;S2 - TEXT ADDR
        PUSH    BX      ;ADDR - BACK TO STACK ( IT RHYMES )
        MOV     AH,0    ;ZERO
        MOV     DX,-1   ;CHAR OFFSET COUNTER
        DEC     BX      ;ADDR -1
;
;   SCAN TO FIRST NON-TERMINATOR CHARACTER
ENCL1:  INC     BX      ;ADDR+1
        INC     DX      ;COUNT+1
        CMP     AL,[BX]
        JZ      ENCL1   ;WAIT FOR NON-TERMINATOR
        PUSH    DX      ;OFFSET TO 1ST TEXT CHAR
        CMP     AH,[BX] ;NULL CHAR?
        JNZ     ENCL2   ;NO
;
;  FOUND NULL BEFORE 1ST NON-TERM CHAR
        MOV     AX,DX   ;COPY COUNTER
        INC     DX      ; +1
        JMP     DPUSH
;
;   FOUND FIRST TEXT CHAR - COUNT THE CHARS
ENCL2:  INC     BX      ; ADDR+1
        INC     DX      ;COUNT+1
        CMP     AL,[BX] ;TERMINATOR CHAR?
        JZ      ENCL4   ;YES
        CMP     AH,[BX] ;NULL CHAR?
        JNZ     ENCL2   ;NO, LOOP AGAIN
;
;   FOUND NULL AT END OF TEXT
ENCL3:  MOV     AX,DX   ;COUNTERS ARE EQUAL
        JMP     DPUSH
;
;   FOUND TERMINATOR CHARACTER
ENCL4:  MOV     AX,DX
        INC     AX      ;COUNT+1
        JMP     DPUSH
;

;  ********** 
;  *   CR   *
;  ********** 
;  
N_CR:     DB   80H+2
         DB      "C"
         DB     "R"+80H
         DW    N_ENCL
CR:      DW     DOCOL
                           
        DW      LIT,LF
        DW      EMIT
        DW      SEMIS
;

;  ************* 
;  *   CMOVE   *
;  ************* 
;  
N_LCMOVE:     DB   80H+5
         DB      "CMOV"
         DB     "E"+80H
         DW    N_CR
LCMOVE:      DW     $+CW
                           
        CLD             ;INC DIRECTION
        MOV     BX,SI   ;SAVE IF
        POP     CX      ;COUNT
        POP     DI      ;DEST
        POP     SI      ;SOURCE
;       MOV    AX,DS
;       MOV    ES,AX   ;ES <- DS
        REP     MOVSB   ;THAT'S THE MOVE
        MOV     SI,BX   ;GET BACK IP
        JMP     NEXT
;

;  ********** 
;  *   U*   *
;  ********** 
;  
N_USTAR:     DB   80H+2
         DB      "U"
         DB     "*"+80H
         DW    N_LCMOVE
USTAR:      DW     $+CW
                           
        POP     AX
        POP     BX
        MUL     BX      ;UNSIGNED
        XCHG    AX,DX   ;AX NOW = MSW
        JMP     DPUSH          ;STORE DOUBLE CELL
;

;  ********** 
;  *   U/   *
;  ********** 
;  
N_USLAS:     DB   80H+2
         DB      "U"
         DB     "/"+80H
         DW    N_USTAR
USLAS:      DW     $+CW
                           
        POP     BX      ;DIVISOR
        POP     DX      ;MSW OF DIVIDEND
        POP     AX      ;LSW OF DIVIDEND
        CMP     DX,BX   ;DICIDE BY 0?
        JNB     DZERO   ; ERROR - ZERO DIVIDE
        DIV     BX      ;16 BIT DIVIDE
        JMP     DPUSH          ;STORE QUOT/REM
;
;      DIVIDE BY ZERO ERROR - SHOW MAX NUMBERS
DZERO:  MOV     AX,-1
        MOV     DX,AX
        JMP     DPUSH          ;STORE QUOT/REM
;

;  *********** 
;  *   AND   *
;  *********** 
;  
N_LAND:     DB   80H+3
         DB      "AN"
         DB     "D"+80H
         DW    N_USLAS
LAND:      DW     $+CW
                           
        POP     AX
        POP     BX
        AND     AX,BX
        JMP     APUSH
;

;  ********** 
;  *   OR   *
;  ********** 
;  
N_LOR:     DB   80H+2
         DB      "O"
         DB     "R"+80H
         DW    N_LAND
LOR:      DW     $+CW
                           
        POP     AX      ; (S1) <- (S1) OR (S2)
        POP     BX
        OR      AX,BX
        JMP     APUSH
;

;  *********** 
;  *   XOR   *
;  *********** 
;  
N_LXOR:     DB   80H+3
         DB      "XO"
         DB     "R"+80H
         DW    N_LOR
LXOR:      DW     $+CW
                           
        POP     AX      ; (S1) <- (S1) XOR (S2)
        POP     BX
        XOR     AX,BX
        JMP     APUSH
;

;  *********** 
;  *   SP@   *
;  *********** 
;  
N_SPFET:     DB   80H+3
         DB      "SP"
         DB     "@"+80H
         DW    N_LXOR
SPFET:      DW     $+CW
                           
        MOV     AX,SP   ; (S1) <- (SP)
        JMP     APUSH
;

;  *********** 
;  *   SP!   *
;  *********** 
;  
N_SPSTO:     DB   80H+3
         DB      "SP"
         DB     "!"+80H
         DW    N_SPFET
SPSTO:      DW     $+CW
                           
        MOV     BX, WORD[USINI+(CW*1)]   ;USER VAR BASE ADDR
        MOV     SP,[BX+(CW*3)]        ;RESET PARAM STACK POINTER
        JMP     NEXT
;

;  *********** 
;  *   RP@   *
;  *********** 
;  
N_RPFET:     DB   80H+3
         DB      "RP"
         DB     "@"+80H
         DW    N_SPSTO
RPFET:      DW     $+CW
                                 ;(S1) <- (RP)
        MOV     AX,BP   ;RETURN STACK ADDR
        JMP     APUSH
;

;  *********** 
;  *   RP!   *
;  *********** 
;  
N_RPSTO:     DB   80H+3
         DB      "RP"
         DB     "!"+80H
         DW    N_RPFET
RPSTO:      DW     $+CW
                           
        MOV     BX, WORD[USINI+(CW*1)]   ;(AX) <- USR VAR BASE
        MOV     BP,[BX+(CW*4)]        ;RESET RETURN STACK PTR
        JMP     NEXT
;

;  ********** 
;  *   ;S   *
;  ********** 
;  
N_SEMIS:     DB   80H+2
         DB      ";"
         DB     "S"+80H
         DW    N_RPSTO
SEMIS:      DW     $+CW
                           
        MOV     SI,[BP] ;(IP) <- (R1)
        LEA     BP,[BP+(CW*1)]
        JMP     NEXT
;

;  ************* 
;  *   LEAVE   *
;  ************* 
;  
N_LLEAV:     DB   80H+5
         DB      "LEAV"
         DB     "E"+80H
         DW    N_SEMIS
LLEAV:      DW     $+CW
                             ;LIMIT <- INDEX
        MOV     AX,[BP] ;GET INDEX
        MOV     [BP+(CW*1)],AX        ;STORE IT AT LIMIT
        JMP     NEXT
        ;
;

;  ********** 
;  *   >R   *
;  ********** 
;  
N_TOR:     DB   80H+2
         DB      ">"
         DB     "R"+80H
         DW    N_LLEAV
TOR:      DW     $+CW
                                   ; (R1) <- (S1)
        POP     BX      ;GET STACK PARAMETER
        LEA     BP,[BP-(CW*1)]    ;MOVE RETURN STACK DOWN
        MOV     [BP],BX ;ADD TO RETURN STACK
        JMP     NEXT
;

;  ********** 
;  *   R>   *
;  ********** 
;  
N_FROMR:     DB   80H+2
         DB      "R"
         DB     ">"+80H
         DW    N_TOR
FROMR:      DW     $+CW
                                 ;(S1) <- (R1)
        MOV     AX,[BP] ; GET RETURN STACK VALUE
        LEA     BP,[BP+(CW*1)]
        JMP     APUSH
;

;  ********* 
;  *   R   *
;  ********* 
;  
N_RR:     DB   80H+1
         DB     "R"+80H
         DW    N_FROMR
RR:      DW     IDO+(CW*1)
                           
;

;  ********** 
;  *   0=   *
;  ********** 
;  
N_ZEQU:     DB   80H+2
         DB      "0"
         DB     "="+80H
         DW    N_RR
ZEQU:      DW     $+CW
                           
        POP     AX
        OR      AX,AX   ;DO TEST
        MOV     AX,1    ;TRUE
        JZ      ZEQU1   ;IT'S 0
        DEC     AX      ;FALSE
ZEQU1:  JMP     APUSH
;

;  ********** 
;  *   0<   *
;  ********** 
;  
N_ZLESS:     DB   80H+2
         DB      "0"
         DB     "<"+80H
         DW    N_ZEQU
ZLESS:      DW     $+CW
                           
        POP     AX
        OR      AX,AX   ;SET FLAGS
        MOV     AX,1    ;TRUE
        JS      ZLESS1
        DEC     AX      ;FALSE
ZLESS1: JMP     APUSH
;

;  ********* 
;  *   +   *
;  ********* 
;  
N_PLUS:     DB   80H+1
         DB     "+"+80H
         DW    N_ZLESS
PLUS:      DW     $+CW
                           
        POP     AX      ;(S1) <- (S1) + (S2)
        POP     BX
        ADD     AX,BX
        JMP     APUSH
;

;  ********** 
;  *   D+   *
;  ********** 
;  
N_DPLUS:     DB   80H+2
         DB      "D"
         DB     "+"+80H
         DW    N_PLUS
DPLUS:      DW     $+CW
                           
        POP     AX      ; YHW
        POP     DX      ; YLW
        POP     BX      ; XHW
        POP     CX      ; XLW
        ADD     DX,CX   ; SLW
        ADC     AX,BX   ; SHW
        JMP     DPUSH
;

;  ************* 
;  *   MINUS   *
;  ************* 
;  
N_MINUS:     DB   80H+5
         DB      "MINU"
         DB     "S"+80H
         DW    N_DPLUS
MINUS:      DW     $+CW
                           
        POP     AX
        NEG     AX
        JMP     APUSH
;

;  ************** 
;  *   DMINUS   *
;  ************** 
;  
N_DMINU:     DB   80H+6
         DB      "DMINU"
         DB     "S"+80H
         DW    N_MINUS
DMINU:      DW     $+CW
                           
        POP     BX
        POP     CX
        SUB     AX,AX
        MOV     DX,AX
        SUB     DX,CX   ; MAKE 2'S COMPLEMENT
        SBB     AX,BX   ; HIGH CELL
        JMP     DPUSH
        ;
;

;  ************ 
;  *   OVER   *
;  ************ 
;  
N_OVER:     DB   80H+4
         DB      "OVE"
         DB     "R"+80H
         DW    N_DMINU
OVER:      DW     $+CW
                           
        POP     DX
        POP     AX
        PUSH    AX
        JMP     DPUSH
;

;  ************ 
;  *   DROP   *
;  ************ 
;  
N_DROP:     DB   80H+4
         DB      "DRO"
         DB     "P"+80H
         DW    N_OVER
DROP:      DW     $+CW
                           
        POP     AX
        JMP     NEXT
;

;  ************ 
;  *   SWAP   *
;  ************ 
;  
N_SWAP:     DB   80H+4
         DB      "SWA"
         DB     "P"+80H
         DW    N_DROP
SWAP:      DW     $+CW
                           
        POP     DX
        POP     AX
        JMP     DPUSH
;

;  *********** 
;  *   DUP   *
;  *********** 
;  
N_LDUP:     DB   80H+3
         DB      "DU"
         DB     "P"+80H
         DW    N_SWAP
LDUP:      DW     $+CW
                           
        POP     AX
        PUSH    AX
        JMP     APUSH
;

;  ************ 
;  *   2DUP   *
;  ************ 
;  
N_TDUP:     DB   80H+4
         DB      "2DU"
         DB     "P"+80H
         DW    N_LDUP
TDUP:      DW     $+CW
                           
        POP     AX
        POP     DX
        PUSH    DX
        PUSH    AX
        JMP     DPUSH
;

;  ********** 
;  *   +!   *
;  ********** 
;  
N_PSTOR:     DB   80H+2
         DB      "+"
         DB     "!"+80H
         DW    N_TDUP
PSTOR:      DW     $+CW
                           
        POP     BX      ;ADDRESS
        POP     AX      ;INCREMENT
        ADD     [BX],AX
        JMP     NEXT
;

;  ************** 
;  *   TOGGLE   *
;  ************** 
;  
N_TOGGL:     DB   80H+6
         DB      "TOGGL"
         DB     "E"+80H
         DW    N_PSTOR
TOGGL:      DW     $+CW
                           
        POP     AX      ;BIT PATTERN
        POP     BX      ;ADDR
        XOR     [BX],AX ;
        JMP     NEXT
;

;  ********* 
;  *   @   *
;  ********* 
;  
N_FETCH:     DB   80H+1
         DB     "@"+80H
         DW    N_TOGGL
FETCH:      DW     $+CW
                           
        POP     BX
        MOV     AX,[BX]
        JMP     APUSH
;

;  ********** 
;  *   C@   *
;  ********** 
;  
N_CFET:     DB   80H+2
         DB      "C"
         DB     "@"+80H
         DW    N_FETCH
CFET:      DW     $+CW
                           
        POP     BX
        XOR     AX,AX
        MOV     AL,[BX]
        JMP     APUSH
;

;  ********** 
;  *   2@   *
;  ********** 
;  
N_TFET:     DB   80H+2
         DB      "2"
         DB     "@"+80H
         DW    N_CFET
TFET:      DW     $+CW
                           
        POP     BX      ;ADDR
        MOV     AX,[BX] ;MSW
        MOV     DX,[BX+(CW*1)]        ;LSW
        JMP     DPUSH
;

;  ********* 
;  *   !   *
;  ********* 
;  
N_STORE:     DB   80H+1
         DB     "!"+80H
         DW    N_TFET
STORE:      DW     $+CW
                           
        POP     BX      ;ADDR
        POP     AX      ;DATA
        MOV     [BX],AX
        JMP     NEXT
;

;  ********** 
;  *   C!   *
;  ********** 
;  
N_CSTOR:     DB   80H+2
         DB      "C"
         DB     "!"+80H
         DW    N_STORE
CSTOR:      DW     $+CW
                           
        POP     BX      ;ADDR
        POP     AX      ;DATA
        MOV     [BX],AL
        JMP     NEXT
;

;  ********** 
;  *   2!   *
;  ********** 
;  
N_TSTOR:     DB   80H+2
         DB      "2"
         DB     "!"+80H
         DW    N_CSTOR
TSTOR:      DW     $+CW
                           
        POP     BX      ;ADDR
        POP     AX      ;MSW
        MOV     [BX],AX
        POP     AX      ;LSW
        MOV     [BX+(CW*1)],AX
        JMP     NEXT
;
;  ********** 
;  *   L@   *
;  ********** 
;  
N_LFET:     DB   80H+2
         DB      "L"
         DB     "@"+80H
         DW    N_TSTOR
LFET:      DW     $+CW
                           
;


        POP     BX      ;MEM LOC
        POP     CX      ;SEG REG VAL
        
        MOV     DX,DS   ; Leave this for real mode code.
        MOV     DS,CX
        MOV     BX,[BX]
        MOV     DS,DX
        
        PUSH    BX
        JMP     NEXT
;
;
;  ********** 
;  *   L!   *
;  ********** 
;  
N_LSTORE:     DB   80H+2
         DB      "L"
         DB     "!"+80H
         DW    N_LFET
LSTORE:      DW     $+CW
                           
;


        POP     BX
        POP     CX
        POP     DX
        
        MOV     AX,DS
        MOV     DS,CX
        MOV     [BX],DX
        MOV     DS,AX
        
        JMP     NEXT
;
;

;  ********* 
;  *   :   *
;  ********* 
;  
N_COLON:     DB   80H+1+40H
         DB     ":"+80H
         DW    N_LSTORE
COLON:      DW     DOCOL
                           
        DW      QEXEC
        DW      SCSP
        DW      CURR
        DW      FETCH
        DW      CONT
        DW      STORE
        DW      CREAT
        DW      RBRAC
        DW      PSCOD
DOCOL:  LEA     BP,[BP-(CW*1)]
        MOV     [BP],SI ;R1 <- (IP)
        LEA     SI,[BX+(CW*1)]  ;(IP) <- (PFA)
;        CALL    DISPLAYSI
;
        JMP     NEXT
;

;  ********* 
;  *   ;   *
;  ********* 
;  
N_SEMI:     DB   80H+1+40H
         DB     ";"+80H
         DW    N_COLON
SEMI:      DW     DOCOL
                           
        DW      QCSP
        DW      COMP
        DW      SEMIS
        DW      SMUDG
        DW      LBRAC
        DW      SEMIS
;

;  **************** 
;  *   CONSTANT   *
;  **************** 
;  
N_CON:     DB   80H+8
         DB      "CONSTAN"
         DB     "T"+80H
         DW    N_SEMI
CON:      DW     DOCOL
                           
        DW      CREAT
        DW      SMUDG
        DW      COMMA
        DW      PSCOD
DOCON:  MOV     AX,[BX+(CW*1)] ;GET DATA FROM PFA
        JMP     APUSH
;

;  **************** 
;  *   VARIABLE   *
;  **************** 
;  
N_VAR:     DB   80H+8
         DB      "VARIABL"
         DB     "E"+80H
         DW    N_CON
VAR:      DW     DOCOL
                           
        DW      CON
        DW      PSCOD
DOVAR:  LEA     AX,[BX+(CW*1)] ;(AX) <- PFA
        JMP     APUSH
;

;  ************ 
;  *   USER   *
;  ************ 
;  
N_USER:     DB   80H+4
         DB      "USE"
         DB     "R"+80H
         DW    N_VAR
USER:      DW     DOCOL
                           
        DW      CON
        DW      PSCOD
DOUSE:  MOV     BX,[BX+(CW*1)] ;PFA  
        MOV     DI, WORD[USINI+(CW*1)]   ;USER VAR ADDRESS
        LEA     AX,[BX+DI]      ;ADDR OF VARIABLE
        JMP     APUSH
;

;  ********* 
;  *   0   *
;  ********* 
;  
N_ZERO:     DB   80H+1
         DB     "0"+80H
         DW    N_USER
ZERO:      DW     $+CW
                           
        XOR     AX,AX
        JMP     APUSH
;

;  ********* 
;  *   1   *
;  ********* 
;  
N_ONE:     DB   80H+1
         DB     "1"+80H
         DW    N_ZERO
ONE:      DW     $+CW
                           
        MOV     AX,1
        JMP     APUSH
;

;  ********* 
;  *   2   *
;  ********* 
;  
N_TWO:     DB   80H+1
         DB     "2"+80H
         DW    N_ONE
TWO:      DW     $+CW
                           
        MOV     AX,2
        JMP     APUSH
;

;  ********* 
;  *   3   *
;  ********* 
;  
N_THREE:     DB   80H+1
         DB     "3"+80H
         DW    N_TWO
THREE:      DW     $+CW
                           
        MOV     AX,3
        JMP     APUSH
;
 ;  ********** 
;  *   BL   *
;  ********** 
;  
N_BLS:     DB   80H+2
         DB      "B"
         DB     "L"+80H
         DW    N_THREE
BLS:      DW     DOCON
                           
; THIS IS ONLY A SPAC
    DW 20H
;

;  *********** 
;  *   C/L   *
;  *********** 
;  
N_CSLL:     DB   80H+3
         DB      "C/"
         DB     "L"+80H
         DW    N_BLS
CSLL:      DW     DOCON
                           
        DW      64
;


;  ************* 
;  *   FIRST   *
;  ************* 
;  
N_FIRST:     DB   80H+5
         DB      "FIRS"
         DB     "T"+80H
         DW    N_CSLL
FIRST:      DW     DOCON
                           
        DW      BUF1
 ;
;
;
;

;  ************* 
;  *   LIMIT   *
;  ************* 
;  
N_LIMIT:     DB   80H+5
         DB      "LIMI"
         DB     "T"+80H
         DW    N_FIRST
LIMIT:      DW     DOCON
                           
        DW      BUF1+(KBBUF+2*CW)*NBUF
; THE END  OF THE MEMORY 

;  ********** 
;  *   EM   *
;  ********** 
;  
N_LEM:     DB   80H+2
         DB      "E"
         DB     "M"+80H
         DW    N_LIMIT
LEM:      DW     DOCON
                           
        DW      EM
;

;  ************* 
;  *   B/BUF   *
;  ************* 
;  
N_BBUF:     DB   80H+5
         DB      "B/BU"
         DB     "F"+80H
         DW    N_LEM
BBUF:      DW     DOCON
                           
        DW      KBBUF
;

;  ************* 
;  *   B/SCR   *
;  ************* 
;  
N_BSCR:     DB   80H+5
         DB      "B/SC"
         DB     "R"+80H
         DW    N_BBUF
BSCR:      DW     DOCON
                           
        DW      400H/KBBUF
;
        ;
;
; All user variables are initialised 
; with the values from USINI.
; The implementation relies on the initialisation of 
; those with numbers (1..11), so change in concord with USINI.

;  ********** 
;  *   U0   *
;  ********** 
;  
N_UZERO:     DB   80H+2
         DB      "U"
         DB     "0"+80H
         DW    N_BSCR
UZERO:      DW     DOUSE
                           
        DW      (CW*1)
;

;  ************** 
;  *   RUBOUT   *
;  ************** 
;  
N_RUBOUT:     DB   80H+6
         DB      "RUBOU"
         DB     "T"+80H
         DW    N_UZERO
RUBOUT:      DW     DOUSE
                           
        DW      (CW*2)
;

;  ********** 
;  *   S0   *
;  ********** 
;  
N_SZERO:     DB   80H+2
         DB      "S"
         DB     "0"+80H
         DW    N_RUBOUT
SZERO:      DW     DOUSE
                           
        DW      (CW*3)
;

;  ********** 
;  *   R0   *
;  ********** 
;  
N_RZERO:     DB   80H+2
         DB      "R"
         DB     "0"+80H
         DW    N_SZERO
RZERO:      DW     DOUSE
                           
        DW      (CW*4)
;

;  *********** 
;  *   TIB   *
;  *********** 
;  
N_TIB:     DB   80H+3
         DB      "TI"
         DB     "B"+80H
         DW    N_RZERO
TIB:      DW     DOUSE
                           
        DW      (CW*5)
;

;  ************* 
;  *   WIDTH   *
;  ************* 
;  
N_WIDTHE:     DB   80H+5
         DB      "WIDT"
         DB     "H"+80H
         DW    N_TIB
WIDTHE:      DW     DOUSE
                           
        DW      (CW*6)
;

;  *************** 
;  *   WARNING   *
;  *************** 
;  
N_WARN:     DB   80H+7
         DB      "WARNIN"
         DB     "G"+80H
         DW    N_WIDTHE
WARN:      DW     DOUSE
                           
        DW      (CW*7)
;

;  ************* 
;  *   FENCE   *
;  ************* 
;  
N_FENCE:     DB   80H+5
         DB      "FENC"
         DB     "E"+80H
         DW    N_WARN
FENCE:      DW     DOUSE
                           
        DW      (CW*8)
;

;  ********** 
;  *   DP   *
;  ********** 
;  
N_LDP:     DB   80H+2
         DB      "D"
         DB     "P"+80H
         DW    N_FENCE
LDP:      DW     DOUSE
                           
        DW      (CW*9)
;

;  **************** 
;  *   VOC-LINK   *
;  **************** 
;  
N_VOCL:     DB   80H+8
         DB      "VOC-LIN"
         DB     "K"+80H
         DW    N_LDP
VOCL:      DW     DOUSE
                           
        DW      (CW*10)
;

;  ************** 
;  *   OFFSET   *
;  ************** 
;  
N_OFSET:     DB   80H+6
         DB      "OFFSE"
         DB     "T"+80H
         DW    N_VOCL
OFSET:      DW     DOUSE
                           
        DW      (CW*11)
;
; End of user variables with fixed place.
;

;  *********** 
;  *   SCR   *
;  *********** 
;  
N_SCR:     DB   80H+3
         DB      "SC"
         DB     "R"+80H
         DW    N_OFSET
SCR:      DW     DOUSE
                           
        DW      (CW*14)
;

;  *************** 
;  *   CONTEXT   *
;  *************** 
;  
N_CONT:     DB   80H+7
         DB      "CONTEX"
         DB     "T"+80H
         DW    N_SCR
CONT:      DW     DOUSE
                           
        DW      (CW*16)
;

;  *************** 
;  *   CURRENT   *
;  *************** 
;  
N_CURR:     DB   80H+7
         DB      "CURREN"
         DB     "T"+80H
         DW    N_CONT
CURR:      DW     DOUSE
                           
        DW      (CW*17)
;

;  ************* 
;  *   STATE   *
;  ************* 
;  
N_STATE:     DB   80H+5
         DB      "STAT"
         DB     "E"+80H
         DW    N_CURR
STATE:      DW     DOUSE
                           
        DW      (CW*18)
;

;  ************ 
;  *   BASE   *
;  ************ 
;  
N_BASE:     DB   80H+4
         DB      "BAS"
         DB     "E"+80H
         DW    N_STATE
BASE:      DW     DOUSE
                           
        DW      (CW*19)
;

;  *********** 
;  *   DPL   *
;  *********** 
;  
N_DPL:     DB   80H+3
         DB      "DP"
         DB     "L"+80H
         DW    N_BASE
DPL:      DW     DOUSE
                           
        DW      (CW*20)
;

;  *********** 
;  *   FLD   *
;  *********** 
;  
N_LFLD:     DB   80H+3
         DB      "FL"
         DB     "D"+80H
         DW    N_DPL
LFLD:      DW     DOUSE
                           
        DW      (CW*21)
;

;  *********** 
;  *   CSP   *
;  *********** 
;  
N_LCSP:     DB   80H+3
         DB      "CS"
         DB     "P"+80H
         DW    N_LFLD
LCSP:      DW     DOUSE
                           
        DW      (CW*22)
;

;  ********** 
;  *   R#   *
;  ********** 
;  
N_RNUM:     DB   80H+2
         DB      "R"
         DB     "#"+80H
         DW    N_LCSP
RNUM:      DW     DOUSE
                           
        DW      (CW*23)
;

;  *********** 
;  *   HLD   *
;  *********** 
;  
N_HLD:     DB   80H+3
         DB      "HL"
         DB     "D"+80H
         DW    N_RNUM
HLD:      DW     DOUSE
                           
        DW      (CW*24)
;

;  ********** 
;  *   IN   *
;  ********** 
;  
N_LIN:     DB   80H+2
         DB      "I"
         DB     "N"+80H
         DW    N_HLD
LIN:      DW     DOUSE
                           
        DW      (CW*25)
;

;  *********** 
;  *   OUT   *
;  *********** 
;  
N_LOUT:     DB   80H+3
         DB      "OU"
         DB     "T"+80H
         DW    N_LIN
LOUT:      DW     DOUSE
                           
        DW      (CW*26)
;

;  *********** 
;  *   BLK   *
;  *********** 
;  
N_BLK:     DB   80H+3
         DB      "BL"
         DB     "K"+80H
         DW    N_LOUT
BLK:      DW     DOUSE
                           
        DW      (CW*27)
;
;========== END USER VARIABLES =============;
;

;  ********** 
;  *   1+   *
;  ********** 
;  
N_ONEP:     DB   80H+2
         DB      "1"
         DB     "+"+80H
         DW    N_BLK
ONEP:      DW     $+CW
                           
        POP     AX
        INC     AX
        JMP     APUSH
;

;  ********** 
;  *   2+   *
;  ********** 
;  
N_TWOP:     DB   80H+2
         DB      "2"
         DB     "+"+80H
         DW    N_ONEP
TWOP:      DW     $+CW
                           
        POP     AX
        ADD     AX,2
        JMP     APUSH
;

;  ************* 
;  *   CELL+   *
;  ************* 
;  
N_CELLP:     DB   80H+5
         DB      "CELL"
         DB     "+"+80H
         DW    N_TWOP
CELLP:      DW     $+CW
                           
        POP     AX
        ADD     AX,CW
        JMP     APUSH
;

;  ************ 
;  *   HERE   *
;  ************ 
;  
N_HERE:     DB   80H+4
         DB      "HER"
         DB     "E"+80H
         DW    N_CELLP
HERE:      DW     DOCOL
                           
        DW      LDP
        DW      FETCH
        DW      SEMIS
;

;  ************* 
;  *   ALLOT   *
;  ************* 
;  
N_ALLOT:     DB   80H+5
         DB      "ALLO"
         DB     "T"+80H
         DW    N_HERE
ALLOT:      DW     DOCOL
                           
        DW      LDP
        DW      PSTOR
        DW      SEMIS
;

;  ********* 
;  *   ,   *
;  ********* 
;  
N_COMMA:     DB   80H+1
         DB     ","+80H
         DW    N_ALLOT
COMMA:      DW     DOCOL
                           
        DW      HERE
        DW      STORE
        DW      TWO
        DW      ALLOT
        DW      SEMIS
;

;  ********** 
;  *   C,   *
;  ********** 
;  
N_CCOMM:     DB   80H+2
         DB      "C"
         DB     ","+80H
         DW    N_COMMA
CCOMM:      DW     DOCOL
                           
        DW      HERE
        DW      CSTOR
        DW      ONE
        DW      ALLOT
        DW      SEMIS
;

;  ********* 
;  *   -   *
;  ********* 
;  
N_LSUB:     DB   80H+1
         DB     "-"+80H
         DW    N_CCOMM
LSUB:      DW     $+CW
                           
        POP     DX      ;S1
        POP     AX
        SUB     AX,DX
        JMP     APUSH   ;S1 = S2 - S1
;

;  ********* 
;  *   =   *
;  ********* 
;  
N_EQUAL:     DB   80H+1
         DB     "="+80H
         DW    N_LSUB
EQUAL:      DW     DOCOL
                           
        DW      LSUB
        DW      ZEQU
        DW      SEMIS
;

;  ********* 
;  *   <   *
;  ********* 
;  
N_LESS:     DB   80H+1
         DB     "<"+80H
         DW    N_EQUAL
LESS:      DW     $+CW
                           
        POP     DX      ;S1
        POP     AX      ;S2
        MOV     BX,DX
        XOR     BX,AX   ;TEST FOR EQUAL SIGNS
        JS      LES1    ;SIGNS ARE NOT THE SAME
        SUB     AX,DX
LES1:   OR      AX,AX   ;TEST SIGN BIT
        MOV     AX,0    ;ASSUME FALSE
        JNS     LES2    ;NOT LESS THAN
        INC     AX      ;TRUE (1)
LES2:   JMP     APUSH
;

;  ********** 
;  *   U<   *
;  ********** 
;  
N_ULESS:     DB   80H+2
         DB      "U"
         DB     "<"+80H
         DW    N_LESS
ULESS:      DW     DOCOL
                           
        DW      TDUP
        DW      LXOR,ZLESS
        DW      ZBRAN
        DW      ULES1-$ ;IF
        DW      DROP,ZLESS
        DW      ZEQU
        DW      BRAN
        DW      ULES2-$
ULES1:  DW      LSUB,ZLESS      ;ELSE
ULES2:  DW      SEMIS           ;ENDIF
;

;  ********* 
;  *   >   *
;  ********* 
;  
N_GREAT:     DB   80H+1
         DB     ">"+80H
         DW    N_ULESS
GREAT:      DW     DOCOL
                           
        DW      SWAP
        DW      LESS
        DW      SEMIS
;

;  *********** 
;  *   ROT   *
;  *********** 
;  
N_ROT:     DB   80H+3
         DB      "RO"
         DB     "T"+80H
         DW    N_GREAT
ROT:      DW     $+CW
                           
        POP     DX      ;S1
        POP     BX      ;S2
        POP     AX      ;S3
        PUSH    BX
        JMP     DPUSH
;

;  ************* 
;  *   SPACE   *
;  ************* 
;  
N_SPACE:     DB   80H+5
         DB      "SPAC"
         DB     "E"+80H
         DW    N_ROT
SPACE:      DW     DOCOL
                           
        DW      BLS
        DW      EMIT
        DW      SEMIS
;

;  ************ 
;  *   -DUP   *
;  ************ 
;  
N_DDUP:     DB   80H+4
         DB      "-DU"
         DB     "P"+80H
         DW    N_SPACE
DDUP:      DW     DOCOL
                           
        DW      LDUP
        DW      ZBRAN
        DW      DDUP1-$ ; IF
        DW      LDUP    ;ENDIF
DDUP1:  DW      SEMIS
;

;  **************** 
;  *   TRAVERSE   *
;  **************** 
;  
N_TRAV:     DB   80H+8
         DB      "TRAVERS"
         DB     "E"+80H
         DW    N_DDUP
TRAV:      DW     DOCOL
                           
        DW      SWAP
TRAV1:  DW      OVER    ;BEGIN
        DW      PLUS
        DW      LIT,7FH
        DW      OVER
        DW      CFET
        DW      LESS
        DW      ZBRAN
        DW      TRAV1-$ ;UNTIL
        DW      SWAP
        DW      DROP
        DW      SEMIS
;

;  ************** 
;  *   LATEST   *
;  ************** 
;  
N_LATES:     DB   80H+6
         DB      "LATES"
         DB     "T"+80H
         DW    N_TRAV
LATES:      DW     DOCOL
                           
        DW      CURR
        DW      FETCH
        DW      FETCH
        DW      SEMIS
;

;  *********** 
;  *   LFA   *
;  *********** 
;  
N_LFA:     DB   80H+3
         DB      "LF"
         DB     "A"+80H
         DW    N_LATES
LFA:      DW     DOCOL
                           
        DW      LIT,(CW*2)
        DW      LSUB
        DW      SEMIS
;

;  *********** 
;  *   CFA   *
;  *********** 
;  
N_CFA:     DB   80H+3
         DB      "CF"
         DB     "A"+80H
         DW    N_LFA
CFA:      DW     DOCOL
                           
        DW      TWO
        DW      LSUB
        DW      SEMIS
;

;  *********** 
;  *   NFA   *
;  *********** 
;  
N_NFA:     DB   80H+3
         DB      "NF"
         DB     "A"+80H
         DW    N_CFA
NFA:      DW     DOCOL
                           
        DW      LIT,1+(CW*2)
        DW      LSUB
        DW      LIT,-1
        DW      TRAV
        DW      SEMIS
;

;  *********** 
;  *   PFA   *
;  *********** 
;  
N_PFA:     DB   80H+3
         DB      "PF"
         DB     "A"+80H
         DW    N_NFA
PFA:      DW     DOCOL
                           
        DW      ONE
        DW      TRAV
        DW      LIT,1+(CW*2)
        DW      PLUS
        DW      SEMIS
        ;
        ; At line     LINE ~1500


;  ************ 
;  *   !CSP   *
;  ************ 
;  
N_SCSP:     DB   80H+4
         DB      "!CS"
         DB     "P"+80H
         DW    N_PFA
SCSP:      DW     DOCOL
                           
        DW      SPFET
        DW      LCSP
        DW      STORE
        DW      SEMIS
;

;  ************** 
;  *   ?ERROR   *
;  ************** 
;  
N_QERR:     DB   80H+6
         DB      "?ERRO"
         DB     "R"+80H
         DW    N_SCSP
QERR:      DW     DOCOL
                           
        DW      SWAP
        DW      ZBRAN
        DW      QERR1-$ ;IF
        DW      ERROR
        DW      BRAN
        DW      QERR2-$  ;ELSE
QERR1:  DW      DROP    ;ENDIF
QERR2:  DW      SEMIS
;

;  ************* 
;  *   ?COMP   *
;  ************* 
;  
N_QCOMP:     DB   80H+5
         DB      "?COM"
         DB     "P"+80H
         DW    N_QERR
QCOMP:      DW     DOCOL
                           
        DW      STATE
        DW      FETCH
        DW      ZEQU
        DW      LIT,11H
        DW      QERR
        DW      SEMIS
;

;  ************* 
;  *   ?EXEC   *
;  ************* 
;  
N_QEXEC:     DB   80H+5
         DB      "?EXE"
         DB     "C"+80H
         DW    N_QCOMP
QEXEC:      DW     DOCOL
                           
        DW      STATE
        DW      FETCH
        DW      LIT,12H
        DW      QERR
        DW      SEMIS
;

;  ************** 
;  *   ?PAIRS   *
;  ************** 
;  
N_QPAIR:     DB   80H+6
         DB      "?PAIR"
         DB     "S"+80H
         DW    N_QEXEC
QPAIR:      DW     DOCOL
                           
        DW      LSUB
        DW      LIT,13H
        DW      QERR
        DW      SEMIS
;

;  ************ 
;  *   ?CSP   *
;  ************ 
;  
N_QCSP:     DB   80H+4
         DB      "?CS"
         DB     "P"+80H
         DW    N_QPAIR
QCSP:      DW     DOCOL
                           
        DW      SPFET
        DW      LCSP
        DW      FETCH
        DW      LSUB
        DW      LIT,14H
        DW      QERR
        DW      SEMIS
;

;  **************** 
;  *   ?LOADING   *
;  **************** 
;  
N_QLOAD:     DB   80H+8
         DB      "?LOADIN"
         DB     "G"+80H
         DW    N_QCSP
QLOAD:      DW     DOCOL
                           
        DW      BLK
        DW      FETCH
        DW      ZEQU
        DW      LIT,16H
        DW      QERR
        DW      SEMIS
;

;  *************** 
;  *   COMPILE   *
;  *************** 
;  
N_COMP:     DB   80H+7
         DB      "COMPIL"
         DB     "E"+80H
         DW    N_QLOAD
COMP:      DW     DOCOL
                           
        DW      QCOMP
        DW      FROMR
        DW      LDUP
        DW      CELLP
        DW      TOR
        DW      FETCH
        DW      COMMA
        DW      SEMIS
;

;  ********* 
;  *   [   *
;  ********* 
;  
N_LBRAC:     DB   80H+1+40H
         DB     "["+80H
         DW    N_COMP
LBRAC:      DW     DOCOL
                           
        DW      ZERO
        DW      STATE
        DW      STORE
        DW      SEMIS
;

;  ********* 
;  *   ]   *
;  ********* 
;  
N_RBRAC:     DB   80H+1
         DB     "]"+80H
         DW    N_LBRAC
RBRAC:      DW     DOCOL
                           
        DW      LIT,0C0H
        DW      STATE
        DW      STORE
        DW      SEMIS
;

;  ************** 
;  *   SMUDGE   *
;  ************** 
;  
N_SMUDG:     DB   80H+6
         DB      "SMUDG"
         DB     "E"+80H
         DW    N_RBRAC
SMUDG:      DW     DOCOL
                           
        DW      LATES
        DW      LIT,20H
        DW      TOGGL
        DW      SEMIS
;

;  *********** 
;  *   HEX   *
;  *********** 
;  
N_HEX:     DB   80H+3
         DB      "HE"
         DB     "X"+80H
         DW    N_SMUDG
HEX:      DW     DOCOL
                           
        DW      LIT,16
        DW      BASE
        DW      STORE
        DW      SEMIS
;

;  *************** 
;  *   DECIMAL   *
;  *************** 
;  
N_DECA:     DB   80H+7
         DB      "DECIMA"
         DB     "L"+80H
         DW    N_HEX
DECA:      DW     DOCOL
                           
        DW      LIT,10
        DW      BASE
        DW      STORE
        DW      SEMIS
;

;  *************** 
;  *   (;CODE)   *
;  *************** 
;  
N_PSCOD:     DB   80H+7
         DB      "(;CODE"
         DB     ")"+80H
         DW    N_DECA
PSCOD:      DW     DOCOL
                           
        DW      FROMR
        DW      LATES
        DW      PFA
        DW      CFA
        DW      STORE
        DW      SEMIS
;

;  ************* 
;  *   ;CODE   *
;  ************* 
;  
N_SEMIC:     DB   80H+5+40H
         DB      ";COD"
         DB     "E"+80H
         DW    N_PSCOD
SEMIC:      DW     DOCOL
                           
        DW      QCSP
        DW      COMP
        DW      PSCOD
        DW      LBRAC
SEMI1:  DW      NOOP    ; The code field of ASSEMBLER must be patched here. 
        DW      SEMIS
;

;  *************** 
;  *   <BUILDS   *
;  *************** 
;  
N_BUILD:     DB   80H+7
         DB      "<BUILD"
         DB     "S"+80H
         DW    N_SEMIC
BUILD:      DW     DOCOL
                           
        DW      ZERO
        DW      CON
        DW      SEMIS
;

;  ************* 
;  *   DOES>   *
;  ************* 
;  
N_DOES:     DB   80H+5
         DB      "DOES"
         DB     ">"+80H
         DW    N_BUILD
DOES:      DW     DOCOL
                           
        DW      FROMR
        DW      LATES
        DW      PFA
        DW      STORE
        DW      PSCOD
DODOE:  LEA     BP,[BP-(CW*1)]
        MOV     [BP],SI ;R1 <- (IP)
        MOV     SI,[BX+(CW*1)] ;NEW IP 
        LEA     AX,[BX+2*(CW*1)]
        JMP     APUSH
;

;  ************* 
;  *   COUNT   *
;  ************* 
;  
N_COUNT:     DB   80H+5
         DB      "COUN"
         DB     "T"+80H
         DW    N_DOES
COUNT:      DW     DOCOL
                           
        DW      LDUP
        DW      ONEP
        DW      SWAP
        DW      CFET
        DW      SEMIS
;

;  ***************** 
;  *   -TRAILING   *
;  ***************** 
;  
N_DTRAI:     DB   80H+9
         DB      "-TRAILIN"
         DB     "G"+80H
         DW    N_COUNT
DTRAI:      DW     DOCOL
                           
        DW      LDUP
        DW      ZERO
        DW      XDO     ;DO
DTRA1:  DW      OVER
        DW      OVER
        DW      PLUS
        DW      ONE
        DW      LSUB
        DW      CFET
        DW      BLS
        DW      LSUB
        DW      ZBRAN
        DW      DTRA2-$ ;IF
        DW      LLEAV
        DW      BRAN
        DW      DTRA3-$  ; ELSE
DTRA2:  DW      ONE
        DW      LSUB    ; ENDIF
DTRA3:  DW      XLOOP
        DW      DTRA1-$    ; LOOP
        DW      SEMIS
        ;
        ; At line     LINE ~2000


;  ************ 
;  *   (.")   *
;  ************ 
;  
_PDOTQ:    DB   80H+4
         DB      '(."'
         DB     ')'+80H
        DW    N_DTRAI
PDOTQ:     DW     DOCOL
                        
        DW      RR
        DW      COUNT
        DW      LDUP
        DW      ONEP
        DW      FROMR
        DW      PLUS
        DW      TOR
        DW      LTYPE
        DW      SEMIS
;


;  ********** 
;  *   ."   *
;  ********** 
;  
_DOTQ:    DB   80H+2+40H
         DB      '.'
         DB     '"'+80H
        DW    _PDOTQ
DOTQ:     DW     DOCOL
                        
        DW      LIT,22H
        DW      STATE
        DW      FETCH
        DW      ZBRAN
        DW      DOTQ1-$ ; IF
        DW      COMP
        DW      PDOTQ
        DW      LWORD
        DW      HERE
        DW      CFET
        DW      ONEP
        DW      ALLOT
        DW      BRAN
        DW      DOTQ2-$  ; ELSE
DOTQ1:  DW      LWORD
        DW      HERE
        DW      COUNT
        DW      LTYPE   ; ENDIF
DOTQ2:  DW      SEMIS
;

;  ************* 
;  *   QUERY   *
;  ************* 
;  
N_QUERY:     DB   80H+5
         DB      "QUER"
         DB     "Y"+80H
         DW    _DOTQ
QUERY:      DW     DOCOL
                           
        DW      TIB
        DW      FETCH
        DW      LIT,RTS/2
        DW      EXPEC
        DW      ZERO
        DW      LIN
        DW      STORE
        DW      SEMIS
;


_NULL:            DB      0C1H,80H
                DW      N_QUERY
NULL:             DW      DOCOL

;       Special header putting an ASCII NULL in the dictionary.
        DW      BLK
        DW      FETCH
        DW      ZBRAN
        DW      NULL1-$ ; IF
        DW      ONE
        DW      BLK
        DW      PSTOR
        DW      ZERO
        DW      LIN
        DW      STORE
        DW      BLK
        DW      FETCH
        DW      BSCR
        DW      ONE
        DW      LSUB
        DW      LAND
        DW      ZEQU
        DW      ZBRAN
        DW      NULL2-$ ; IF
        DW      QEXEC
        DW      FROMR
        DW      DROP    ; ENDIF
NULL2:  DW      BRAN
        DW      NULL3-$  ; ELSE
NULL1:  DW      FROMR
        DW      DROP    ; ENDIF
NULL3:  DW      SEMIS
;

;  ************ 
;  *   FILL   *
;  ************ 
;  
N_FILL:     DB   80H+4
         DB      "FIL"
         DB     "L"+80H
         DW    _NULL
FILL:      DW     $+CW
                           
        POP     AX      ; FILL CHAR
        POP     CX      ; FILL COUNT
        POP     DI      ; BEGIN ADDR
;       MOV    BX,DS
;       MOV    ES,BX   ; ES <- DS
        CLD             ; INC DIRECTION
        REP     STOSB   ;STORE BYTE
        JMP     NEXT
;

;  ************* 
;  *   ERASE   *
;  ************* 
;  
N_LERASE:     DB   80H+5
         DB      "ERAS"
         DB     "E"+80H
         DW    N_FILL
LERASE:      DW     DOCOL
                           
        DW      ZERO
        DW      FILL
        DW      SEMIS
;

;  ************** 
;  *   BLANKS   *
;  ************** 
;  
N_BLANK:     DB   80H+6
         DB      "BLANK"
         DB     "S"+80H
         DW    N_LERASE
BLANK:      DW     DOCOL
                           
        DW      BLS
        DW      FILL
        DW      SEMIS
;

;  ************ 
;  *   HOLD   *
;  ************ 
;  
N_HOLD:     DB   80H+4
         DB      "HOL"
         DB     "D"+80H
         DW    N_BLANK
HOLD:      DW     DOCOL
                           
        DW      LIT,-1
        DW      HLD
        DW      PSTOR
        DW      HLD
        DW      FETCH
        DW      CSTOR
        DW      SEMIS
;

;  *********** 
;  *   PAD   *
;  *********** 
;  
N_PAD:     DB   80H+3
         DB      "PA"
         DB     "D"+80H
         DW    N_HOLD
PAD:      DW     DOCOL
                           
        DW      HERE
        DW      LIT,84
        DW      PLUS
        DW      SEMIS
;

;  ************ 
;  *   WORD   *
;  ************ 
;  
N_LWORD:     DB   80H+4
         DB      "WOR"
         DB     "D"+80H
         DW    N_PAD
LWORD:      DW     DOCOL
                           
        DW      BLK
        DW      FETCH
        DW      ZBRAN
        DW      WORD1-$ ; IF
        DW      BLK
        DW      FETCH
        DW      BLOCK
        DW      BRAN
        DW      WORD2-$  ; ELSE
WORD1:  DW      TIB
        DW      FETCH      ; ENDIF
WORD2:  DW      LIN
        DW      FETCH
        DW      PLUS
        DW      SWAP
        DW      ENCL
        DW      HERE
        DW      LIT,22H
        DW      BLANK
        DW      LIN
        DW      PSTOR
        DW      OVER
        DW      LSUB
        DW      TOR
        DW      RR
        DW      HERE
        DW      CSTOR
        DW      PLUS
        DW      HERE
        DW      ONEP
        DW      FROMR
        DW      LCMOVE
        DW      SEMIS
;

;  **************** 
;  *   (NUMBER)   *
;  **************** 
;  
N_PNUMB:     DB   80H+8
         DB      "(NUMBER"
         DB     ")"+80H
         DW    N_LWORD
PNUMB:      DW     DOCOL
                           
PNUM1:  DW      ONEP    ; BEGIN
        DW      LDUP
        DW      TOR
        DW      CFET
        DW      BASE
        DW      FETCH
        DW      DIGIT
        DW      ZBRAN
        DW      PNUM2-$ ; WHILE
        DW      SWAP
        DW      BASE
        DW      FETCH
        DW      USTAR
        DW      DROP
        DW      ROT
        DW      BASE
        DW      FETCH
        DW      USTAR
        DW      DPLUS
        DW      DPL
        DW      FETCH
        DW      ONEP
        DW      ZBRAN
        DW      PNUM3-$ ; IF
        DW      ONE
        DW      DPL
        DW      PSTOR   ; ENDIF
PNUM3:  DW      FROMR
        DW      BRAN
        DW      PNUM1-$  ; REPEAT
PNUM2:  DW      FROMR
        DW      SEMIS
;

;  ************** 
;  *   NUMBER   *
;  ************** 
;  
N_NUMB:     DB   80H+6
         DB      "NUMBE"
         DB     "R"+80H
         DW    N_PNUMB
NUMB:      DW     DOCOL
                           
        DW      ZERO
        DW      ZERO
        DW      ROT
        DW      LDUP
        DW      ONEP
        DW      CFET
        DW      LIT,2DH
        DW      EQUAL
        DW      LDUP
        DW      TOR
        DW      PLUS
        DW      LIT,-1
NUMB1:  DW      DPL     ; BEGIN
        DW      STORE
        DW      PNUMB
        DW      LDUP
        DW      CFET
        DW      BLS
        DW      LSUB
        DW      ZBRAN
        DW      NUMB2-$ ; WHILE
        DW      LDUP
        DW      CFET
        DW      LIT,2EH
        DW      LSUB
        DW      ZERO
        DW      QERR
        DW      ZERO
        DW      BRAN
        DW      NUMB1-$  ; REPEAT
NUMB2:  DW      DROP
        DW      FROMR
        DW      ZBRAN
        DW      NUMB3-$ ; IF
        DW      DMINU   ; ENDIF
NUMB3:  DW      SEMIS
;

;  ************* 
;  *   -FIND   *
;  ************* 
;  
N_DFIND:     DB   80H+5
         DB      "-FIN"
         DB     "D"+80H
         DW    N_NUMB
DFIND:      DW     DOCOL
                           
        DW      BLS
        DW      LWORD
        DW      HERE
        DW      CONT
        DW      FETCH
        DW      FETCH
        DW      PFIND
        DW      LDUP
        DW      ZEQU
        DW      ZBRAN
        DW      DFIN1-$ ;IF
        DW      DROP
        DW      HERE
        DW      LATES
        DW      PFIND   ;ENDIF
DFIN1:  DW      SEMIS
;

;  *************** 
;  *   (ABORT)   *
;  *************** 
;  
N_PABOR:     DB   80H+7
         DB      "(ABORT"
         DB     ")"+80H
         DW    N_DFIND
PABOR:      DW     DOCOL
                           
        DW      ABORT
        DW      SEMIS
;

;  ************* 
;  *   ERROR   *
;  ************* 
;  
N_ERROR:     DB   80H+5
         DB      "ERRO"
         DB     "R"+80H
         DW    N_PABOR
ERROR:      DW     DOCOL
                           
        DW      WARN
        DW      FETCH
        DW      ZLESS
        DW      ZBRAN
        DW      ERRO1-$ ;IF
        DW      PABOR   ;ENDIF
ERRO1:  DW      HERE
        DW      COUNT
        DW      LTYPE
        DW      PDOTQ
        
        DB      2
        DB      "? "
        DW      MESS
        DW      SPSTO
;
;      CHANGE FROM FIG MODEL
;      DC LIN,FETCH,BLK,FETCH
;
        DW      BLK,FETCH
        DW      DDUP
        DW      ZBRAN
        DW      ERRO2-$ ; IF
        DW      LIN,FETCH
        DW      SWAP    ;ENDIF
ERRO2:  DW      QUIT
;

;  *********** 
;  *   ID.   *
;  *********** 
;  
N_IDDOT:     DB   80H+3
         DB      "ID"
         DB     "."+80H
         DW    N_ERROR
IDDOT:      DW     DOCOL
                           
        DW      COUNT
        DW      LIT,1FH
        DW      LAND
        DW      ONE
        DW      LSUB
        DW      TDUP
        DW      LTYPE
        DW      PLUS
        DW      CFET
        DW      LIT,07FH
        DW      LAND
        DW      EMIT
        DW      SPACE
        DW      SPACE
        DW      SPACE
        DW      SEMIS
;

;  ************** 
;  *   CREATE   *
;  ************** 
;  
N_CREAT:     DB   80H+6
         DB      "CREAT"
         DB     "E"+80H
         DW    N_IDDOT
CREAT:      DW     DOCOL
                           
        DW      DFIND
        DW      HERE
        DW      ONEP
        DW      CFET
        DW      ZEQU
        DW      LIT,5
        DW      QERR
        DW      ZBRAN
        DW      CREA1-$ ;IF
        DW      DROP
        DW      NFA
        DW      IDDOT
        DW      LIT,4
        DW      MESS
        DW      SPACE   ;ENDIF
CREA1:  DW      HERE
        DW      LDUP
        DW      CFET
        DW      WIDTHE
        DW      FETCH
        DW      MIN
        DW      ONEP
        DW      ALLOT
        DW      LDUP
        DW      LIT,0A0H
        DW      TOGGL
        DW      HERE
        DW      ONE
        DW      LSUB
        DW      LIT,80H
        DW      TOGGL
        DW      LATES
        DW      COMMA
        DW      CURR
        DW      FETCH
        DW      STORE
        DW      HERE
        DW      CELLP
        DW      COMMA
        DW      SEMIS
        ;

;  ***************** 
;  *   [COMPILE]   *
;  ***************** 
;  
N_BCOMP:     DB   80H+9+40H
         DB      "[COMPILE"
         DB     "]"+80H
         DW    N_CREAT
BCOMP:      DW     DOCOL
                           
        DW      DFIND
        DW      ZEQU
        DW      ZERO
        DW      QERR
        DW      DROP
        DW      CFA
        DW      COMMA
        DW      SEMIS
;

;  *************** 
;  *   LITERAL   *
;  *************** 
;  
N_LITER:     DB   80H+7+40H
         DB      "LITERA"
         DB     "L"+80H
         DW    N_BCOMP
LITER:      DW     DOCOL
                           
        DW      STATE
        DW      FETCH
        DW      ZBRAN
        DW      LITE1-$ ;IF
        DW      COMP
        DW      LIT
        DW      COMMA   ;ENDIF
LITE1:  DW      SEMIS
        ;
;

;  **************** 
;  *   DLITERAL   *
;  **************** 
;  
N_DLITE:     DB   80H+8+40H
         DB      "DLITERA"
         DB     "L"+80H
         DW    N_LITER
DLITE:      DW     DOCOL
                           
        DW      STATE
        DW      FETCH
        DW      ZBRAN
        DW      DLIT1-$ ; IF
        DW      SWAP
        DW      LITER
        DW      LITER   ; ENDIF
DLIT1:  DW      SEMIS
;

;  ************** 
;  *   ?STACK   *
;  ************** 
;  
N_QSTAC:     DB   80H+6
         DB      "?STAC"
         DB     "K"+80H
         DW    N_DLITE
QSTAC:      DW     DOCOL
                           
        DW      SPFET
        DW      SZERO
        DW      FETCH
        DW      SWAP
        DW      ULESS
        DW      ONE
        DW      QERR
        DW      SPFET
        DW      HERE
        DW      LIT,80H
        DW      PLUS
        DW      ULESS
        DW      LIT,7
        DW      QERR
        DW      SEMIS
        ;
;

;  ***************** 
;  *   INTERPRET   *
;  ***************** 
;  
N_INTER:     DB   80H+9
         DB      "INTERPRE"
         DB     "T"+80H
         DW    N_QSTAC
INTER:      DW     DOCOL
                           
INTE1:  DW      DFIND   ;BEGIN
        DW      ZBRAN
        DW      INTE2-$ ;IF
        DW      STATE
        DW      FETCH
        DW      LESS
        DW      ZBRAN
        DW      INTE3-$ ;IF
        DW      CFA
        DW      COMMA
        DW      BRAN
        DW      INTE4-$  ;ELSE
INTE3:  DW      CFA
        DW      EXEC    ;ENDIF
INTE4:  DW      QSTAC
        DW      BRAN
        DW      INTE5-$  ;ELSE
INTE2:  DW      HERE
        DW      NUMB
        DW      DPL
        DW      FETCH
        DW      ONEP
        DW      ZBRAN
        DW      INTE6-$ ;IF
        DW      DLITE
        DW      BRAN
        DW      INTE7-$  ;ELSE
INTE6:  DW      DROP
        DW      LITER   ;ENDIF
INTE7:  DW      QSTAC   ;ENDIF
INTE5:  DW      BRAN
        DW      INTE1-$  ;AGAIN
;

;  ***************** 
;  *   IMMEDIATE   *
;  ***************** 
;  
N_IMMED:     DB   80H+9
         DB      "IMMEDIAT"
         DB     "E"+80H
         DW    N_INTER
IMMED:      DW     DOCOL
                           
        DW      LATES
        DW      LIT,40H
        DW      TOGGL
        DW      SEMIS
;

;  ****************** 
;  *   VOCABULARY   *
;  ****************** 
;  
N_VOCAB:     DB   80H+10
         DB      "VOCABULAR"
         DB     "Y"+80H
         DW    N_IMMED
VOCAB:      DW     DOCOL
                           
        DW      BUILD
        DW      LIT, 80H+1, CCOMM    ; Dummy name field
        DW      LIT, " "+80H, CCOMM
        DW      CURR
        DW      FETCH
        DW      LIT, 2, LSUB ; Skip backwards over dummy name field.
        DW      COMMA    ; DLFA points to NFA of CURRENT
        DW      HERE
        DW      VOCL
        DW      FETCH
        DW      COMMA    ; VLFA points to VLFA of previous VOC-LINK
        DW      VOCL
        DW      STORE
        DW      DOES
DOVOC:  DW      TWOP    ; i.e. Skip ' ' name.
        DW      CONT
        DW      STORE
        DW      SEMIS
        ;
;
;   The link to task is a cold start value only.
;   It is updated each time a definition is
;   appended to the 'FORTH' vocabulary.
;

;  ************* 
;  *   FORTH   *
;  ************* 
;  
N_FORTH:     DB   80H+5+40H
         DB      "FORT"
         DB     "H"+80H
         DW    N_VOCAB
FORTH:      DW     DODOE
                           
        DW      DOVOC
        DB      80H+1, " "+80H  ; Dummy name field
        DW      N_TASK
        DW      0       ; END OF VOCABULARY LIST
;

;  ******************* 
;  *   DEFINITIONS   *
;  ******************* 
;  
N_DEFIN:     DB   80H+11
         DB      "DEFINITION"
         DB     "S"+80H
         DW    N_FORTH
DEFIN:      DW     DOCOL
                           
        DW      CONT
        DW      FETCH
        DW      CURR
        DW      STORE
        DW      SEMIS
;

;  ********* 
;  *   (   *
;  ********* 
;  
N_PAREN:     DB   80H+1+40H
         DB     "("+80H
         DW    N_DEFIN
PAREN:      DW     DOCOL
                           
        DW      LIT,')'
        DW      LWORD
        DW      SEMIS
;

;  ************ 
;  *   QUIT   *
;  ************ 
;  
N_QUIT:     DB   80H+4
         DB      "QUI"
         DB     "T"+80H
         DW    N_PAREN
QUIT:      DW     DOCOL
                           
        DW      ZERO
        DW      BLK
        DW      STORE
        DW      LBRAC
QUIT1:  DW      RPSTO   ;BEGIN
        DW      CR
        DW      QUERY
        DW      INTER
        DW      STATE
        DW      FETCH
        DW      ZEQU
        DW      ZBRAN
        DW      QUIT2-$ ;IF
        DW      PDOTQ
        
        DB      2
        DB      "OK"   ;ENDIF
QUIT2:  DW      BRAN
        DW      QUIT1-$  ;AGAIN
;

;  ************* 
;  *   ABORT   *
;  ************* 
;  
N_ABORT:     DB   80H+5
         DB      "ABOR"
         DB     "T"+80H
         DW    N_QUIT
ABORT:      DW     DOCOL
                           
        DW      SPSTO
        DW      DECA
        DW      QSTAC   ; IT DID TO & INCL THIS
        DW      CR
        DW      DOTCPU
        DW      PDOTQ

%if 0
;       If this is there it is an official release
        DB      22
        DB      'IBM-PC Fig-Forth'
        DB      FIGREL+30H,ADOT,FIGREV+30H,ADOT,USRVER+30H
%endif
;       If this is there it is a beta release
        
        DB      50
        DB      "IBM-PC $RCSfile: fig86.gnr,v $ $Revision: 2.148 $ "
        DW      FORTH
        DW      DEFIN
        DW      QUIT
        ;
;      WARM START VECTOR COMES HERE
;
WRM:    MOV     SI, WRM1
        JMP     NEXT
;
WRM1:   DW      WARM
;

;  ************ 
;  *   WARM   *
;  ************ 
;  
N_WARM:     DB   80H+4
         DB      "WAR"
         DB     "M"+80H
         DW    N_ABORT
WARM:      DW     DOCOL
                           
        DW      MTBUF
        DW      ABORT
;
;      COLD START VECTOR COMES HERE
;
LCLD:    MOV     SI, CLD1  ; (IP) <-
%if 0

        PUSH    DS
        MOV     AX,0
        MOV     DS,AX           ;TO VECTOR AREA
        MOV     BX,08CH
        LEA     AX,[WRM]
        MOV     [BX],AX         ;JUMP TO WRM ON <CTRL-BREAK>
        INC     BX
        INC     BX
        MOV     [BX],CS
        POP     DS
 ;
%endif
        CLD                     ; DIR = INC
        MOV     SP, WORD[USINI+(CW*3)]    ;PARAM. STACK
        MOV     BP, WORD[USINI+(CW*4)]    ;RETURN STACK
        JMP     NEXT
;
CLD1:   DW      COLD
;

;  ************ 
;  *   COLD   *
;  ************ 
;  
N_COLD:     DB   80H+4
         DB      "COL"
         DB     "D"+80H
         DW    N_WARM
COLD:      DW     DOCOL
                           
        DW      MTBUF
        DW      FIRST
        DW      USE,STORE
        DW      FIRST
        DW      PREV,STORE
        DW      LIT, USINI
        DW      LIT,USINI+(CW*1)
        DW      FETCH
        DW      LIT,US
        DW      LCMOVE
        DW      LIT,USINI + (CW*0)    ; I.e. lfa of TASK
        DW      FETCH
        DW      LIT,FORTH+2+(CW*2)
        DW      STORE
;

        DW      BLINI
;
        DW      ABORT
;
        ;

;  ************ 
;  *   S->D   *
;  ************ 
;  
N_STOD:     DB   80H+4
         DB      "S->"
         DB     "D"+80H
         DW    N_COLD
STOD:      DW     $+CW
                           
        POP     DX      ;S1
        SUB     AX,AX
        OR      DX,DX
        JNS     STOD1   ;POS
        DEC     AX      ;NEG
STOD1:  JMP     DPUSH
;

;  ********** 
;  *   +-   *
;  ********** 
;  
N_PM:     DB   80H+2
         DB      "+"
         DB     "-"+80H
         DW    N_STOD
PM:      DW     DOCOL
                           
        DW      ZLESS
        DW      ZBRAN
        DW      PM1-$   ;IF
        DW      MINUS   ;ENDIF
PM1:    DW      SEMIS
;

;  *********** 
;  *   D+-   *
;  *********** 
;  
N_DPM:     DB   80H+3
         DB      "D+"
         DB     "-"+80H
         DW    N_PM
DPM:      DW     DOCOL
                           
        DW      ZLESS
        DW      ZBRAN
        DW      DPM1-$  ;IF
        DW      DMINU   ;ENDIF
DPM1:   DW      SEMIS
;

;  *********** 
;  *   ABS   *
;  *********** 
;  
N_LABS:     DB   80H+3
         DB      "AB"
         DB     "S"+80H
         DW    N_DPM
LABS:      DW     DOCOL
                           
        DW      LDUP
        DW      PM
        DW      SEMIS
;

;  ************ 
;  *   DABS   *
;  ************ 
;  
N_DABS:     DB   80H+4
         DB      "DAB"
         DB     "S"+80H
         DW    N_LABS
DABS:      DW     DOCOL
                           
        DW      LDUP
        DW      DPM
        DW      SEMIS
;

;  *********** 
;  *   MIN   *
;  *********** 
;  
N_MIN:     DB   80H+3
         DB      "MI"
         DB     "N"+80H
         DW    N_DABS
MIN:      DW     DOCOL
                           
        DW      TDUP
        DW      GREAT
        DW      ZBRAN
        DW      MIN1-$  ;IF
        DW      SWAP    ;ENDIF
MIN1:   DW      DROP
        DW      SEMIS
;

;  *********** 
;  *   MAX   *
;  *********** 
;  
N_MAX:     DB   80H+3
         DB      "MA"
         DB     "X"+80H
         DW    N_MIN
MAX:      DW     DOCOL
                           
        DW      TDUP
        DW      LESS
        DW      ZBRAN
        DW      MAX1-$  ;IF
        DW      SWAP    ;ENDIF
MAX1:   DW      DROP
        DW      SEMIS
;

;  ********** 
;  *   M*   *
;  ********** 
;  
N_MSTAR:     DB   80H+2
         DB      "M"
         DB     "*"+80H
         DW    N_MAX
MSTAR:      DW     DOCOL
                           
        DW      TDUP
        DW      LXOR
        DW      TOR
        DW      LABS
        DW      SWAP
        DW      LABS
        DW      USTAR
        DW      FROMR
        DW      DPM
        DW      SEMIS
;

;  ********** 
;  *   M/   *
;  ********** 
;  
N_MSLAS:     DB   80H+2
         DB      "M"
         DB     "/"+80H
         DW    N_MSTAR
MSLAS:      DW     DOCOL
                           
        DW      OVER
        DW      TOR
        DW      TOR
        DW      DABS
        DW      RR
        DW      LABS
        DW      USLAS
        DW      FROMR
        DW      RR
        DW      LXOR
        DW      PM
        DW      SWAP
        DW      FROMR
        DW      PM
        DW      SWAP
        DW      SEMIS
;

;  ********* 
;  *   *   *
;  ********* 
;  
N_STAR:     DB   80H+1
         DB     "*"+80H
         DW    N_MSLAS
STAR:      DW     DOCOL
                           
        DW      MSTAR
        DW      DROP
        DW      SEMIS
;

;  ************ 
;  *   /MOD   *
;  ************ 
;  
N_SLMOD:     DB   80H+4
         DB      "/MO"
         DB     "D"+80H
         DW    N_STAR
SLMOD:      DW     DOCOL
                           
        DW      TOR
        DW      STOD
        DW      FROMR
        DW      MSLAS
        DW      SEMIS
;

;  ********* 
;  *   /   *
;  ********* 
;  
N_SLASH:     DB   80H+1
         DB     "/"+80H
         DW    N_SLMOD
SLASH:      DW     DOCOL
                           
        DW      SLMOD
        DW      SWAP
        DW      DROP
        DW      SEMIS
;

;  *********** 
;  *   MOD   *
;  *********** 
;  
N_LMOD:     DB   80H+3
         DB      "MO"
         DB     "D"+80H
         DW    N_SLASH
LMOD:      DW     DOCOL
                           
        DW      SLMOD
        DW      DROP
        DW      SEMIS
;

;  ************* 
;  *   */MOD   *
;  ************* 
;  
N_SSMOD:     DB   80H+5
         DB      "*/MO"
         DB     "D"+80H
         DW    N_LMOD
SSMOD:      DW     DOCOL
                           
        DW      TOR
        DW      MSTAR
        DW      FROMR
        DW      MSLAS
        DW      SEMIS
;

;  ********** 
;  *   */   *
;  ********** 
;  
N_SSLA:     DB   80H+2
         DB      "*"
         DB     "/"+80H
         DW    N_SSMOD
SSLA:      DW     DOCOL
                           
        DW      SSMOD
        DW      SWAP
        DW      DROP
        DW      SEMIS
;

;  ************* 
;  *   M/MOD   *
;  ************* 
;  
N_MSMOD:     DB   80H+5
         DB      "M/MO"
         DB     "D"+80H
         DW    N_SSLA
MSMOD:      DW     DOCOL
                           
        DW      TOR
        DW      ZERO
        DW      RR
        DW      USLAS
        DW      FROMR
        DW      SWAP
        DW      TOR
        DW      USLAS
        DW      FROMR
        DW      SEMIS
;

;  ************** 
;  *   (LINE)   *
;  ************** 
;  
N_PLINE:     DB   80H+6
         DB      "(LINE"
         DB     ")"+80H
         DW    N_MSMOD
PLINE:      DW     DOCOL
                           
        DW      TOR
        DW      LIT,64
        DW      BBUF
        DW      SSMOD
        DW      FROMR
        DW      BSCR
        DW      STAR
        DW      PLUS
        DW      BLOCK
        DW      PLUS
        DW      LIT,64
        DW      SEMIS
;

;  ************* 
;  *   .LINE   *
;  ************* 
;  
N_DLINE:     DB   80H+5
         DB      ".LIN"
         DB     "E"+80H
         DW    N_PLINE
DLINE:      DW     DOCOL
                           
        DW      PLINE
        DW      DTRAI
        DW      LTYPE
        DW      SEMIS
;

;  *************** 
;  *   MESSAGE   *
;  *************** 
;  
N_MESS:     DB   80H+7
         DB      "MESSAG"
         DB     "E"+80H
         DW    N_DLINE
MESS:      DW     DOCOL
                           
        DW      WARN
        DW      FETCH
        DW      ZBRAN
        DW      MESS1-$ ;IF
        DW      DDUP
        DW      ZBRAN
        DW      MESS2-$ ;IF
        DW      LIT,4
        DW      DLINE
        DW      SPACE   ;ENDIF
MESS2:  DW      BRAN
        DW      MESS3-$  ;ELSE
MESS1:  DW      PDOTQ
        
        DB      6
        DB      "MSG # "
        DW      DOT     ;ENDIF
MESS3:  DW      SEMIS
;

;  *********** 
;  *   PC@   *
;  *********** 
;  
N_PCFET:     DB   80H+3
         DB      "PC"
         DB     "@"+80H
         DW    N_MESS
PCFET:      DW     $+CW
                           
; FETCH CHARACTER (BYTE) FROM PORT
        POP     DX      ; PORT ADDR
        XOR     AX,AX
        IN      AL,DX   ; BYTE INPUT
        JMP     APUSH
;

;  *********** 
;  *   PC!   *
;  *********** 
;  
N_PCSTO:     DB   80H+3
         DB      "PC"
         DB     "!"+80H
         DW    N_PCFET
PCSTO:      DW     $+CW
                           
        POP     DX      ;PORT ADDR
        POP     AX      ;DATA
        OUT     DX,AL   ; BYTE OUTPUT
        JMP     NEXT
;

;  ********** 
;  *   P@   *
;  ********** 
;  
N_PFET:     DB   80H+2
         DB      "P"
         DB     "@"+80H
         DW    N_PCSTO
PFET:      DW     $+CW
                           
        POP     DX      ;PORT ADDR
        IN      AX,DX   ;WORD INPUT
        JMP     APUSH
;

;  ********** 
;  *   P!   *
;  ********** 
;  
N_PSTO:     DB   80H+2
         DB      "P"
         DB     "!"+80H
         DW    N_PFET
PSTO:      DW     $+CW
                           
        POP     DX      ;PORT ADDR
        POP     AX      ;DATA
        OUT     DX,AX   ;WORD OUTPUT
        JMP     NEXT
;

;  *********** 
;  *   USE   *
;  *********** 
;  
N_USE:     DB   80H+3
         DB      "US"
         DB     "E"+80H
         DW    N_PSTO
USE:      DW     DOVAR
                           
        DW BUF1
;

;  ************ 
;  *   PREV   *
;  ************ 
;  
N_PREV:     DB   80H+4
         DB      "PRE"
         DB     "V"+80H
         DW    N_USE
PREV:      DW     DOVAR
                           
        DW      BUF1
;

;  ************* 
;  *   #BUFF   *
;  ************* 
;  
N_NOBUF:     DB   80H+5
         DB      "#BUF"
         DB     "F"+80H
         DW    N_PREV
NOBUF:      DW     DOCON
                           
        ;NO. OF BUFFERS
        DW      NBUF
;

;  ************ 
;  *   +BUF   *
;  ************ 
;  
N_PBUF:     DB   80H+4
         DB      "+BU"
         DB     "F"+80H
         DW    N_NOBUF
PBUF:      DW     DOCOL
                           
        DW      LIT,(KBBUF+2*CW)
        DW      PLUS,LDUP
        DW      LIMIT,EQUAL
        DW      ZBRAN
        DW      PBUF1-$
        DW      DROP,FIRST
PBUF1:  DW      LDUP,PREV
        DW      FETCH,LSUB
        DW      SEMIS
;

;  ************** 
;  *   UPDATE   *
;  ************** 
;  
N_UPDAT:     DB   80H+6
         DB      "UPDAT"
         DB     "E"+80H
         DW    N_PBUF
UPDAT:      DW     DOCOL
                           
        DW      PREV
        DW      FETCH,FETCH
        DW      LIT,BMASK
        DW      LOR
        DW      PREV,FETCH
        DW      STORE,SEMIS
;

;  ********************* 
;  *   EMPTY-BUFFERS   *
;  ********************* 
;  
N_MTBUF:     DB   80H+13
         DB      "EMPTY-BUFFER"
         DB     "S"+80H
         DW    N_UPDAT
MTBUF:      DW     DOCOL
                           
        DW      FIRST
        DW      LIMIT,OVER
        DW      LSUB,LERASE
        DW      SEMIS
        ;
;

;  ************** 
;  *   BUFFER   *
;  ************** 
;  
N_BUFFE:     DB   80H+6
         DB      "BUFFE"
         DB     "R"+80H
         DW    N_MTBUF
BUFFE:      DW     DOCOL
                           
; NOTE: THIS WORD WON'T WORK IF ONLY USING SINGLE BUFFER
        DW      USE
        DW      FETCH,LDUP
        DW      TOR
BUFF1:  DW      PBUF
        DW      ZBRAN
        DW      BUFF1-$
        DW      USE,STORE
        DW      RR,FETCH
        DW      ZLESS
        DW      ZBRAN
        DW      BUFF2-$
        DW      RR,CELLP
        DW      RR,FETCH
        DW      LIT,7FFFH
        DW      LAND,ZERO
        DW      RSLW
BUFF2:  DW      RR,STORE
        DW      RR,PREV
        DW      STORE,FROMR
        DW      CELLP,SEMIS
;

;  ************* 
;  *   BLOCK   *
;  ************* 
;  
N_BLOCK:     DB   80H+5
         DB      "BLOC"
         DB     "K"+80H
         DW    N_BUFFE
BLOCK:      DW     DOCOL
                           
        DW      LIT, PMASK, LAND
        DW      OFSET
        DW      FETCH,PLUS
        DW      TOR,PREV
        DW      FETCH,LDUP
        DW      FETCH,RR
        DW      LSUB
        DW      LDUP,PLUS
        DW      ZBRAN
        DW      BLOC1-$
BLOC2:  DW      PBUF,ZEQU
        DW      ZBRAN
        DW      BLOC3-$
        DW      DROP,RR
        DW      BUFFE,LDUP
        DW      RR,ONE
        DW      RSLW
        DW      TWO,LSUB
BLOC3:  DW      LDUP,FETCH
        DW      RR,LSUB
        DW      LDUP,PLUS
        DW      ZEQU
        DW      ZBRAN
        DW      BLOC2-$
        DW      LDUP,PREV
        DW      STORE
BLOC1:  DW      FROMR,DROP
        DW      CELLP,SEMIS
;

;  ************* 
;  *   FLUSH   *
;  ************* 
;  
N_FLUSH:     DB   80H+5
         DB      "FLUS"
         DB     "H"+80H
         DW    N_BLOCK
FLUSH:      DW     DOCOL
                           
        DW      NOBUF,ONEP
        DW      ZERO,XDO
FLUS1:  DW      ZERO,BUFFE
        DW      DROP
        DW      XLOOP
        DW      FLUS1-$
        DW      SEMIS
;

;  ************ 
;  *   LOAD   *
;  ************ 
;  
N_LOAD:     DB   80H+4
         DB      "LOA"
         DB     "D"+80H
         DW    N_FLUSH
LOAD:      DW     DOCOL
                           
        DW      BLK
        DW      FETCH,TOR
        DW      LIN,FETCH
        DW      TOR,ZERO
        DW      LIN,STORE
        DW      BSCR,STAR
        DW      BLK,STORE       ;BLK <- SCR * B/SCR
        DW      INTER   ;INTERPRET FROM OTHER
SCREEN: DW      FROMR,LIN
        DW      STORE
        DW      FROMR,BLK
        DW      STORE
        DW      SEMIS
;

;  *********** 
;  *   -->   *
;  *********** 
;  
N_ARROW:     DB   80H+3+40H
         DB      "--"
         DB     ">"+80H
         DW    N_LOAD
ARROW:      DW     DOCOL
                           
        DW      QLOAD
        DW      ZERO
        DW      LIN
        DW      STORE
        DW      BSCR
        DW      BLK
        DW      FETCH
        DW      OVER
        DW      LMOD
        DW      LSUB
        DW      BLK
        DW      PSTOR
        DW      SEMIS
        ;
;


; Generic call on BIOS. A boon for experimenters.
; Because there is no such thing as a variable interrupt:
; THIS IS SELF MODIFYING CODE! NOT REENTRANT! DO NOT PUT IN ROM!
; BEWARE OF THE SOFTWARE POLICE!
;  ************ 
;  *   BIOS   *
;  ************ 
;  
N_BIOS:     DB   80H+4
         DB      "BIO"
         DB     "S"+80H
         DW    N_ARROW
BIOS:      DW     $+CW
                           
        POP     AX      ; Function code
        ; Once we are more acknowledgable, put segment overwrite here.
        MOV     BYTE [RQBIOS+1],AL ; Patch the code.
        POP     DX
        POP     CX
        POP     BX
        POP     AX
        PUSH     SI      ; Save Forth registers. NEEDED? 
        PUSH     BP
        XCHG    SI,AX   ; Save AX in (already free) SI
        
        XCHG    SI,AX
RQBIOS: INT(0)          ; Request number to be overwritten.
        PUSHF      ; Save status into DI 
        POP     DI
        XCHG    SI,AX  ; Save AX in (still free) SI     
        
        XCHG    SI,AX
        POP     BP      ; Restore Forth registers. NEEDED? 
        POP     SI      ;INTERPRETER PNTR
        PUSH     AX
        PUSH     BX
        PUSH     CX
        PUSH     DX
        PUSH     DI     ; i.e. flags 
        JMP     NEXT

; SELF MODIFYING CODE ENDS HERE! YOU HAVE BEEN WARNED!


;  ************ 
;  *   BDOS   *
;  ************ 
;  
N_BDOS:     DB   80H+4
         DB      "BDO"
         DB     "S"+80H
         DW    N_BIOS
BDOS:      DW     $+CW
                           
        POP     DX
        POP     CX
        POP     BX
        POP     AX
        PUSH     SI      ; Save Forth registers. NEEDED? 
        PUSH     BP
        XCHG    SI,AX   ; Save AX in (already free) SI
        
        XCHG    SI,AX
        INT     21H
        PUSHF      ; Save status into DI 
        POP     DI ; Not EDI! 
        XCHG    SI,AX   ; Save AX in (still free) SI     
        
;        XCHG    SI,AX   ; This is more correct actually.
        XCHG    SI,AX
        POP     BP      ; Restore Forth registers. NEEDED? 
        POP     SI      ;INTERPRETER PNTR
        PUSH     AX
        PUSH     BX
        PUSH     CX
        PUSH     DX
        PUSH     DI     ; i.e. flags 
        JMP     NEXT
;
;


             ; SVGA-modus 43*132 char's
;  ************* 
;  *   SMALL   *
;  ************* 
;  
N_SMALL:     DB   80H+5
         DB      "SMAL"
         DB     "L"+80H
         DW    N_BDOS
SMALL:      DW     DOCOL
                           
             DW      LIT, 4F02H, LIT, 010AH, ZERO, ZERO
             DW      LIT, 0010H, BIOS
             DW      DROP, DROP, DROP, DROP, DROP, SEMIS
             ;                          ^ MUST BE 4FH
;
        ;
;------------------------------------
;       SYSTEM DEPENDANT CHAR I/O
;------------------------------------


;  ************ 
;  *   TYPE   *
;  ************ 
;  
N_LTYPE:     DB   80H+4
         DB      "TYP"
         DB     "E"+80H
         DW    N_SMALL
LTYPE:      DW     DOCOL
                           
        DW      LDUP, LOUT, PSTOR
        DW      TOR     ;  Count.



        DW      TOR     ;  Buffer address.
        DW      LIT,04000H ; Write file or device 
        DW      ONE     ; Handle
        DW      FROMR, FROMR, SWAP
         
        DW      BDOS, DROP ; ignore error 
        DW      DROP, DROP, DROP, DROP
        DW      SEMIS

;

;  ************ 
;  *   EMIT   *
;  ************ 
;  
N_EMIT:     DB   80H+4
         DB      "EMI"
         DB     "T"+80H
         DW    N_LTYPE
EMIT:      DW     DOCOL
                           
        DW      LDUP,LIT,LF,EQUAL
        DW      ZBRAN
        DW      EMIT1-$
        DW      LIT,ACR,EMIT
        DW      ZERO,LOUT,STORE
EMIT1:
        DW      SPFET, ONE, LTYPE
        DW      DROP
        DW      SEMIS
;

 ;  ************** 
;  *   EXPECT   *
;  ************** 
;  
N_EXPEC:     DB   80H+6
         DB      "EXPEC"
         DB     "T"+80H
         DW    N_EMIT
EXPEC:      DW     DOCOL
                           


        DW      OVER
        DW      TOR, TOR
        DW      LIT,03F00H ; Write file or device 
        DW      ZERO     ; Handle
        DW      FROMR, FROMR
         
        DW      BDOS, DROP ; ignore error 
        DW      DROP, DROP, DROP ; Leave count
        DW      TWO, LSUB ; Rid of 0D0A


        DW      PLUS, ZERO, SWAP, CSTOR
        DW      SEMIS

;

;  *********** 
;  *   KEY   *
;  *********** 
;  
N_KEY:     DB   80H+3
         DB      "KE"
         DB     "Y"+80H
         DW    N_EXPEC
KEY:      DW     DOCOL
                           
        DW         LIT, 1000H, ZERO, ZERO, ZERO
        DW         LIT, 0016H, BIOS
        DW         DROP,DROP,DROP,DROP
        DW         LIT, 00FFH, LAND, SEMIS
;

;  ***************** 
;  *   ?TERMINAL   *
;  ***************** 
;  
N_QTERM:     DB   80H+9
         DB      "?TERMINA"
         DB     "L"+80H
         DW    N_KEY
QTERM:      DW     DOCOL
                           
        DW      LIT,0B00H
        DW      ZERO,ZERO,ZERO
        DW      BDOS, DROP ; ignore error 
        DW      DROP, DROP, DROP
        DW      LIT, 01H, LAND
        DW      SEMIS
;
 ;
;
;
;
;
;
;
        ;
;------------------------------------
;       SYSTEM DEPENDANT DISK I/O
;------------------------------------



;  ****************** 
;  *   BLOCK-FILE   *
;  ****************** 
;  
N_BLFL:     DB   80H+10
         DB      "BLOCK-FIL"
         DB     "E"+80H
         DW    N_QTERM
BLFL:      DW     DOVAR
                           
        
        DB      10
        DB      "BLOCKS.BLK"
        RESB    30-9               ; Allow for some path

;  ******************** 
;  *   BLOCK-HANDLE   *
;  ******************** 
;  
N_BHAN:     DB   80H+12
         DB      "BLOCK-HANDL"
         DB     "E"+80H
         DW    N_BLFL
BHAN:      DW     DOVAR
                           
        DW      -1
;
;
;


;  **************** 
;  *   DISK-ERR   *
;  **************** 
;  
N_DERR:     DB   80H+8
         DB      "DISK-ER"
         DB     "R"+80H
         DW    N_BHAN
DERR:      DW     DOCOL
                           
        DW      ONE, LAND
        DW      LIT, 08H, QERR
        DW      SEMIS
;

;  ****************** 
;  *   BLOCK-INIT   *
;  ****************** 
;  
N_BLINI:     DB   80H+10
         DB      "BLOCK-INI"
         DB     "T"+80H
         DW    N_DERR
BLINI:      DW     DOCOL
                           
        DW      LIT, 03D02H    ; Open file for read/write
        DW      ZERO,ZERO
        DW      BLFL
        DW      COUNT, OVER, PLUS
        DW      ZERO, SWAP, CSTOR  ; Zero ended as required
         
        DW      BDOS
        DW      ONE, LAND, ZEQU, WARN, STORE
        DW      DROP, DROP, DROP
        DW      BHAN, STORE
        DW      SEMIS
;

;  ****************** 
;  *   BLOCK-EXIT   *
;  ****************** 
;  
N_BLEXI:     DB   80H+10
         DB      "BLOCK-EXI"
         DB     "T"+80H
         DW    N_BLINI
BLEXI:      DW     DOCOL
                           
        DW      LIT, 03E00H    ; Close file 
        DW      ZERO, WARN, STORE
        DW      BHAN, FETCH
        DW      ZERO, ZERO
        DW      BDOS, DERR
        DW      DROP, DROP, DROP, DROP
        DW      LIT, -1, BHAN, STORE
        DW      SEMIS
;

;  ************ 
;  *   SEEK   *
;  ************ 
;  
N_SEEK:     DB   80H+4
         DB      "SEE"
         DB     "K"+80H
         DW    N_BLEXI
SEEK:      DW     DOCOL
                           
        DW      BHAN, FETCH
        DW      SWAP, TOR, TOR
        DW      LIT, 04200H     ; Seek from start
        DW      FROMR           ; Handle
        DW      FROMR, BBUF
        DW      USTAR,SWAP    ; L.S. ON TOP
            ; L.S. ON TOP
        DW      BDOS, DERR
        DW      DROP, DROP, DROP, DROP
        DW      SEMIS
;

;  *********** 
;  *   R/W   *
;  *********** 
;  
N_RSLW:     DB   80H+3
         DB      "R/"
         DB     "W"+80H
         DW    N_SEEK
RSLW:      DW     DOCOL
                           
        DW      ZBRAN
        DW      RSLW1-$
        DW      LIT, 03F00H     ; Disk read 
        DW      BRAN
        DW      RSLW2-$
RSLW1:  DW      LIT, 04000H     ; Disk write
RSLW2:  DW      TOR
        DW      SEEK ; That's done
        DW      FROMR, SWAP, TOR
        DW      BHAN, FETCH
        DW      BBUF
        DW      FROMR           ; ADDR
        
        DW      BDOS, DERR
        DW      DROP, DROP, DROP
        DW      BBUF, LSUB, DERR
        DW      SEMIS

;
;
;

;
;
;
;
;
;
        ;
        ; At line     LINE ~3500

;  ********* 
;  *   '   *
;  ********* 
;  
N_TICK:     DB   80H+1+40H
         DB     "'"+80H
         DW    N_RSLW
TICK:      DW     DOCOL
                           
        DW      DFIND
        DW      ZEQU
        DW      ZERO
        DW      QERR
        DW      DROP
        DW      LITER
        DW      SEMIS
;

;  ****************** 
;  *   FORGET-VOC   *
;  ****************** 
;  
N_FORGV:     DB   80H+10
         DB      "FORGET-VO"
         DB     "C"+80H
         DW    N_TICK
FORGV:      DW     DOCOL
                           
        DW      TDUP
        DW      ULESS
        DW      ZBRAN
        DW      FORGV1-$
;        Vocabulary itself is also forgotten.
        DW      FORTH
        DW      DEFIN
        DW      FETCH     ; Unlink by linking next vocabulary.
        DW      VOCL
        DW      STORE
        DW      BRAN
        DW      FORGV2-$
FORGV1: ;  Forget part of contents.
        DW      SWAP
        DW      TOR
        DW      LIT,2+(CW*1)
        DW      LSUB    ;  TOS is now phantom NFA.
        DW      LDUP
FORGV3:
        DW      PFA
        DW      LFA
        DW      FETCH
        DW      LDUP
        DW      RR
        DW      ULESS
        DW      ZBRAN
        DW      FORGV3-$
        DW      SWAP
        DW      TWOP    ;  Skip over " "-name.
        DW      STORE
        DW      FROMR
FORGV2: DW      SEMIS
;

;  ************** 
;  *   FORGET   *
;  ************** 
;  
N_FORG:     DB   80H+6
         DB      "FORGE"
         DB     "T"+80H
         DW    N_FORGV
FORG:      DW     DOCOL
                           
        DW      CURR
        DW      FETCH
        DW      CONT
        DW      FETCH
        DW      LSUB
        DW      LIT,18H
        DW      QERR
        DW      TICK
        DW      LDUP
        DW      FENCE
        DW      FETCH
        DW      LESS
        DW      LIT,15H
        DW      QERR
        DW      LDUP
        DW      NFA
        DW      LIT,FORGV
        DW      FORV
        DW      DROP
        DW      SEMIS
;

;  ************ 
;  *   BACK   *
;  ************ 
;  
N_BACK:     DB   80H+4
         DB      "BAC"
         DB     "K"+80H
         DW    N_FORG
BACK:      DW     DOCOL
                           
        DW      HERE
        DW      LSUB
        DW      COMMA
        DW      SEMIS
;

;  ************* 
;  *   BEGIN   *
;  ************* 
;  
N_BEGIN:     DB   80H+5+40H
         DB      "BEGI"
         DB     "N"+80H
         DW    N_BACK
BEGIN:      DW     DOCOL
                           
        DW      QCOMP
        DW      HERE
        DW      ONE
        DW      SEMIS
;

;  ************* 
;  *   ENDIF   *
;  ************* 
;  
N_LENDIF:     DB   80H+5+40H
         DB      "ENDI"
         DB     "F"+80H
         DW    N_BEGIN
LENDIF:      DW     DOCOL
                           
        DW      QCOMP
        DW      TWO     ; Magic number
        DW      QPAIR
        DW      HERE
        DW      OVER
        DW      LSUB
        DW      SWAP
        DW      STORE
        DW      SEMIS
;

;  ************ 
;  *   THEN   *
;  ************ 
;  
N_THEN:     DB   80H+4+40H
         DB      "THE"
         DB     "N"+80H
         DW    N_LENDIF
THEN:      DW     DOCOL
                           
        DW      LENDIF
        DW      SEMIS
;

;  ********** 
;  *   DO   *
;  ********** 
;  
N_DO:     DB   80H+2+40H
         DB      "D"
         DB     "O"+80H
         DW    N_THEN
DO:      DW     DOCOL
                           
        DW      COMP
        DW      XDO
        DW      HERE
        DW      THREE   ; Magic number
        DW      SEMIS
;

;  ************ 
;  *   LOOP   *
;  ************ 
;  
N_LLOOP:     DB   80H+4+40H
         DB      "LOO"
         DB     "P"+80H
         DW    N_DO
LLOOP:      DW     DOCOL
                           
        DW      THREE   ; Magic number
        DW      QPAIR
        DW      COMP
        DW      XLOOP
        DW      BACK
        DW      SEMIS
;

;  ************* 
;  *   +LOOP   *
;  ************* 
;  
N_PLOOP:     DB   80H+5+40H
         DB      "+LOO"
         DB     "P"+80H
         DW    N_LLOOP
PLOOP:      DW     DOCOL
                           
        DW      THREE   ; Magic number
        DW      QPAIR
        DW      COMP
        DW      XPLOO
        DW      BACK
        DW      SEMIS
;

;  ************* 
;  *   UNTIL   *
;  ************* 
;  
N_UNTIL:     DB   80H+5+40H
         DB      "UNTI"
         DB     "L"+80H
         DW    N_PLOOP
UNTIL:      DW     DOCOL
                           
        DW      ONE
        DW      QPAIR
        DW      COMP
        DW      ZBRAN
        DW      BACK
        DW      SEMIS
;

;  *********** 
;  *   END   *
;  *********** 
;  
N_LEND:     DB   80H+3+40H
         DB      "EN"
         DB     "D"+80H
         DW    N_UNTIL
LEND:      DW     DOCOL
                           
        DW      UNTIL
        DW      SEMIS
;

;  ************* 
;  *   AGAIN   *
;  ************* 
;  
N_AGAIN:     DB   80H+5+40H
         DB      "AGAI"
         DB     "N"+80H
         DW    N_LEND
AGAIN:      DW     DOCOL
                           
        DW      ONE
        DW      QPAIR
        DW      COMP
        DW      BRAN
        DW      BACK
        DW      SEMIS
;

;  ************** 
;  *   REPEAT   *
;  ************** 
;  
N_REPEA:     DB   80H+6+40H
         DB      "REPEA"
         DB     "T"+80H
         DW    N_AGAIN
REPEA:      DW     DOCOL
                           
        DW      TOR
        DW      TOR
        DW      AGAIN
        DW      FROMR
        DW      FROMR
        DW      TWO     ; Magic number
        DW      LSUB
        DW      LENDIF
        DW      SEMIS
;

;  ********** 
;  *   IF   *
;  ********** 
;  
N_LIF:     DB   80H+2+40H
         DB      "I"
         DB     "F"+80H
         DW    N_REPEA
LIF:      DW     DOCOL
                           
        DW      COMP
        DW      ZBRAN
        DW      HERE
        DW      ZERO
        DW      COMMA
        DW      TWO     ; Magic number           
        DW      SEMIS
;

;  ************ 
;  *   ELSE   *
;  ************ 
;  
N_LELSE:     DB   80H+4+40H
         DB      "ELS"
         DB     "E"+80H
         DW    N_LIF
LELSE:      DW     DOCOL
                           
        DW      TWO     ; Magic number 
        DW      QPAIR
        DW      COMP
        DW      BRAN
        DW      HERE
        DW      ZERO
        DW      COMMA
        DW      SWAP
        DW      TWO     ; Magic number           
        DW      LENDIF
        DW      TWO     ; Magic number           
        DW      SEMIS
;

;  ************* 
;  *   WHILE   *
;  ************* 
;  
N_WHILE:     DB   80H+5+40H
         DB      "WHIL"
         DB     "E"+80H
         DW    N_LELSE
WHILE:      DW     DOCOL
                           
        DW      LIF
        DW      TWOP        ; Magic number           
        DW      SEMIS
;

;  ************** 
;  *   SPACES   *
;  ************** 
;  
N_SPACES:     DB   80H+6
         DB      "SPACE"
         DB     "S"+80H
         DW    N_WHILE
SPACES:      DW     DOCOL
                           
        DW      ZERO
        DW      MAX
        DW      DDUP
        DW      ZBRAN
        DW      SPAX1-$
        DW      ZERO
        DW      XDO     ;DO
SPAX2:  DW      SPACE
        DW      XLOOP
        DW      SPAX2-$    ;LOOP
SPAX1:  DW      SEMIS
;

;  ********** 
;  *   <#   *
;  ********** 
;  
N_BDIGS:     DB   80H+2
         DB      "<"
         DB     "#"+80H
         DW    N_SPACES
BDIGS:      DW     DOCOL
                           
        DW      PAD
        DW      HLD
        DW      STORE
        DW      SEMIS
;

;  ********** 
;  *   #>   *
;  ********** 
;  
N_EDIGS:     DB   80H+2
         DB      "#"
         DB     ">"+80H
         DW    N_BDIGS
EDIGS:      DW     DOCOL
                           
        DW      DROP
        DW      DROP
        DW      HLD
        DW      FETCH
        DW      PAD
        DW      OVER
        DW      LSUB
        DW      SEMIS
;

;  ************ 
;  *   SIGN   *
;  ************ 
;  
N_SIGN:     DB   80H+4
         DB      "SIG"
         DB     "N"+80H
         DW    N_EDIGS
SIGN:      DW     DOCOL
                           
        DW      ROT
        DW      ZLESS
        DW      ZBRAN
        DW      SIGN1-$ ;IF
        DW      LIT,2DH
        DW      HOLD    ;ENDIF
SIGN1:  DW      SEMIS
;

;  ********* 
;  *   #   *
;  ********* 
;  
N_DIG:     DB   80H+1
         DB     "#"+80H
         DW    N_SIGN
DIG:      DW     DOCOL
                           
        DW      BASE
        DW      FETCH
        DW      MSMOD
        DW      ROT
        DW      LIT,9
        DW      OVER
        DW      LESS
        DW      ZBRAN
        DW      DIG1-$  ;IF
        DW      LIT,7
        DW      PLUS    ;ENDIF
DIG1:   DW      LIT,30H
        DW      PLUS
        DW      HOLD
        DW      SEMIS
;

;  ********** 
;  *   #S   *
;  ********** 
;  
N_DIGS:     DB   80H+2
         DB      "#"
         DB     "S"+80H
         DW    N_DIG
DIGS:      DW     DOCOL
                           
DIGS1:  DW      DIG     ;BEGIN
        DW      OVER
        DW      OVER
        DW      LOR
        DW      ZEQU
        DW      ZBRAN
        DW      DIGS1-$ ;UNTIL
        DW      SEMIS
;

;  *********** 
;  *   D.R   *
;  *********** 
;  
N_DDOTR:     DB   80H+3
         DB      "D."
         DB     "R"+80H
         DW    N_DIGS
DDOTR:      DW     DOCOL
                           
        DW      TOR
        DW      SWAP
        DW      OVER
        DW      DABS
        DW      BDIGS
        DW      DIGS
        DW      SIGN
        DW      EDIGS
        DW      FROMR
        DW      OVER
        DW      LSUB
        DW      SPACES
        DW      LTYPE
        DW      SEMIS
;

;  ********** 
;  *   .R   *
;  ********** 
;  
N_DOTR:     DB   80H+2
         DB      "."
         DB     "R"+80H
         DW    N_DDOTR
DOTR:      DW     DOCOL
                           
        DW      TOR
        DW      STOD
        DW      FROMR
        DW      DDOTR
        DW      SEMIS
;

;  ********** 
;  *   D.   *
;  ********** 
;  
N_DDOT:     DB   80H+2
         DB      "D"
         DB     "."+80H
         DW    N_DOTR
DDOT:      DW     DOCOL
                           
        DW      ZERO
        DW      DDOTR
        DW      SPACE
        DW      SEMIS
;

;  ********* 
;  *   .   *
;  ********* 
;  
N_DOT:     DB   80H+1
         DB     "."+80H
         DW    N_DDOT
DOT:      DW     DOCOL
                           
        DW      STOD
        DW      DDOT
        DW      SEMIS
;

;  ********* 
;  *   ?   *
;  ********* 
;  
N_QUES:     DB   80H+1
         DB     "?"+80H
         DW    N_DOT
QUES:      DW     DOCOL
                           
        DW      FETCH
        DW      DOT
        DW      SEMIS
;

;  ********** 
;  *   U.   *
;  ********** 
;  
N_UDOT:     DB   80H+2
         DB      "U"
         DB     "."+80H
         DW    N_QUES
UDOT:      DW     DOCOL
                           
        DW      ZERO
        DW      DDOT
        DW      SEMIS
;

;  ***************** 
;  *   FOR-WORDS   *
;  ***************** 
;  
N_FORW:     DB   80H+9
         DB      "FOR-WORD"
         DB     "S"+80H
         DW    N_UDOT
FORW:      DW     DOCOL
                           
        DW      TOR
        DW      CONT
        DW      FETCH
        DW      FETCH
        DW      TOR
FORW1:  DW      FROMR
        DW      RR
        DW      OVER
        DW      PFA
        DW      LFA
        DW      FETCH
        DW      TOR
        DW      EXEC
        DW      RR
        DW      ZEQU
        DW      ZBRAN
        DW      FORW1-$
        DW      FROMR
        DW      DROP
        DW      FROMR
        DW      DROP
        DW      SEMIS
;

;  **************** 
;  *   FOR-VOCS   *
;  **************** 
;  
N_FORV:     DB   80H+8
         DB      "FOR-VOC"
         DB     "S"+80H
         DW    N_FORW
FORV:      DW     DOCOL
                           
        DW      TOR
        DW      VOCL
        DW      FETCH
        DW      TOR
FORV1:  DW      FROMR
        DW      RR
        DW      OVER
        DW      FETCH
        DW      TOR
        DW      EXEC
        DW      RR
        DW      ZEQU
        DW      ZBRAN
        DW      FORV1-$
        DW      FROMR
        DW      DROP
        DW      FROMR
        DW      DROP
        DW      SEMIS
;

;  ************* 
;  *   VLIST   *
;  ************* 
;  
N_VLIST:     DB   80H+5
         DB      "VLIS"
         DB     "T"+80H
         DW    N_FORV
VLIST:      DW     DOCOL
                           
        DW      CSLL
        DW      LOUT
        DW      STORE
        DW      LIT, IDDOT
        DW      FORW
        DW      SEMIS
;


;  *********** 
;  *   BYE   *
;  *********** 
;  
N_BYE:     DB   80H+3
         DB      "BY"
         DB     "E"+80H
         DW    N_VLIST
BYE:      DW     DOCOL
                           
        DW      LIT, 4CH, ZERO, ZERO, ZERO, LIT, 21H, BIOS
; EXIT TO PC-DOS
;
;
;
;

;  ************ 
;  *   LIST   *
;  ************ 
;  
N_LLIST:     DB   80H+4
         DB      "LIS"
         DB     "T"+80H
         DW    N_BYE
LLIST:      DW     DOCOL
                           
        DW      DECA
        DW      CR,LDUP
        DW      SCR,STORE
        DW      PDOTQ
        
        DB      6
        DB      "SCR # "
        DW      DOT
        DW      LIT,10H
        DW      ZERO,XDO
LIST1:  DW      CR,IDO
        DW      LIT,3
        DW      DOTR,SPACE
        DW      IDO,SCR
        DW      FETCH,DLINE
        DW      QTERM   ; ?TERMINAL
        DW      ZBRAN
        DW      LIST2-$
        DW      LLEAV
LIST2:  DW      XLOOP
        DW      LIST1-$
        DW      CR,SEMIS
;

;  ************* 
;  *   INDEX   *
;  ************* 
;  
N_INDEX:     DB   80H+5
         DB      "INDE"
         DB     "X"+80H
         DW    N_LLIST
INDEX:      DW     DOCOL
                           
        DW      LIT,FF
        DW      EMIT,CR
        DW      ONEP,SWAP
        DW      XDO
INDE1:  DW      CR,IDO
        DW      LIT,3
        DW      DOTR,SPACE
        DW      ZERO,IDO
        DW      DLINE,QTERM
        DW      ZBRAN
        DW      INDE2-$
        DW      LLEAV
INDE2:  DW      XLOOP
        DW      INDE1-$
        DW      SEMIS
;

;  ************* 
;  *   TRIAD   *
;  ************* 
;  
N_TRIAD:     DB   80H+5
         DB      "TRIA"
         DB     "D"+80H
         DW    N_INDEX
TRIAD:      DW     DOCOL
                           
        DW      LIT,FF
        DW      EMIT
        DW      LIT,3
        DW      SLASH
        DW      LIT,3
        DW      STAR
        DW      LIT,3
        DW      OVER,PLUS
        DW      SWAP,XDO
TRIA1:  DW      CR,IDO
        DW      LLIST
        DW      QTERM   ; ?TERMINAL
        DW      ZBRAN
        DW      TRIA2-$
        DW      LLEAV   ;LEAVE
TRIA2:  DW      XLOOP
        DW      TRIA1-$    ;ENDIF
        DW      CR
        DW      SEMIS
; This word is not even fig!

;  ************ 
;  *   .CPU   *
;  ************ 
;  
N_DOTCPU:     DB   80H+4
         DB      ".CP"
         DB     "U"+80H
         DW    N_TRIAD
DOTCPU:      DW     DOCOL
                           
; PRINT CPU TYPE (8088)
        DW      BASE,FETCH
        DW      LIT,36
        DW      BASE,STORE
        DW      LIT,(CW*12),PORIG ;
        DW      TFET
;
        DW      DDOT
        DW      BASE,STORE
        DW      SEMIS
;
;           CODE LEVEL "MATCH" DEFINITIONS
;

;  ************* 
;  *   MATCH   *
;  ************* 
;  
N_MATCH:     DB   80H+5
         DB      "MATC"
         DB     "H"+80H
         DW    N_DOTCPU
MATCH:      DW     $+CW
                           
        MOV     DI,SI   ; SAVE IP
        POP     CX      ; STRING COUNT
        POP     BX      ;STRING ADDR
        POP     DX      ;BYTES LEFT TO SEARCH
        POP     SI      ;CURSOR ADDR
        PUSH    SI      ;SAVE COPY
MAT1:   LODSB           ;GET FIRST BYTE
        CMP     AL,[BX] ;MATCH?
        JNZ     MAT3    ;NO
        PUSH    BX      ;SAVE STRING ADDR
        PUSH    CX      ; &   STRING COUNT
        PUSH    SI      ; &   CURSOR ADDR
; TRY TO MATCH REMAINING CHARS IN STRING
;
MAT2:   DEC     CX      ;STR. COUNT -1
        JZ      MATCHOK ;EXIT - MATCH FOUND
        DEC     DX      ;BYTES LEFT -1
        JZ      NOMATCH ;EXIT - NO MATCH
        INC     BX      ;NEXT STR CHAR ADDR
        LODSB           ;GET FIRST BYTE
        CMP     AL,[BX] ;MATCH?
        JZ      MAT2    ;YES, GET MORE
; NO MATCH YET
        POP     SI
        POP     CX
        POP     BX      ;RESTORE POINTERS
MAT3:   DEC     DX      ;BYTE LEFT COUNT -1
        JNZ     MAT1    ;START OVER
        JMP     MAT4    ;EXIT...NO MATCH
MATCHOK:
NOMATCH:
        POP     CX      ;ADJUST STACK
        POP     CX      ;FOR EXIT
        POP     CX
; EXIT HERE: DX = TRUE/FALSE FLAG ( 0=NO MATCH)
;
MAT4:   MOV     AX,SI   ;NEW CURSOR ADDR
        POP     SI      ;GET STARTING ADDR
        SUB     AX,SI   ;COMPUTE CURSOR OFFSET
        MOV     SI,DI   ;GET BACK UP
        JMP     DPUSH          ; BYE..BYE
        ;

;

;  ************** 
;  *   LOW-DP   *
;  ************** 
;  
N_LOWDP:     DB   80H+6
         DB      "LOW-D"
         DB     "P"+80H
         DW    N_MATCH
LOWDP:      DW     DOUSE
                           
        DW      (CW*14)
;

;  ************** 
;  *   LOW-EM   *
;  ************** 
;  
N_LOWEM:     DB   80H+6
         DB      "LOW-E"
         DB     "M"+80H
         DW    N_LOWDP
LOWEM:      DW     DOUSE
                           
        DW      (CW*15)
;
;
;
;**** LAST DICTIONARY WORD ****

;  ************ 
;  *   TASK   *
;  ************ 
;  
N_TASK:     DB   80H+4
         DB      "TAS"
         DB     "K"+80H
         DW    N_LOWEM
TASK:      DW     DOCOL
                           
        DW      SEMIS
;

TEXTEND  EQU     $       ; Show end of dictionary.
INITDP   EQU     TEXTEND ;Where we want new words.
 ;

%if 0

The remaining memory ( up to 'EM' ) is
used for:

        1. EXTENSION DICTIONARY
        2. PARAMETER STACK
        3. TERMINAL INPUT BUFFER
        4. RETURN STACK
        5. USER VARIABLE AREA
        6. DISK BUFFERS (UNLESS REQURIED <1 MBYTE)


%endif

;
;

 ;    ENDS
        ;
%if 0

  MISC. NOTES AND SCATTERED THOUGHTS

- This source will assemble on all platforms where NASM is
  available by the command line:
  nasm -fbin fig86.asm -o fig86.com
  (There may be exceptions for special configurations.)
  The result will run on MSDOS systems only, or stand alone
  an an IBM-compatible computer

- In a MODERN version <ctrl> P  will echo all output to the
  printer. This is not programmed here, but a feature of the OS.
  The operating system may make available a command history too.

- Use the installation manual.  Descriptions for all FIG
  words are given.  Those ERROR messages you get in FORTH
  correspond to the relative line numbers in blocks
  4 and 5 of the installation manual's model.

- Remember that all the FORTH words in this version are
  upper case letters.  Use <CAPS LOCK> when in FORTH.

- Changing variable EM will allow you to create a larger
  dictionary space.  However I suggest you develop and
  DEBUG with EM set to 4000H.  Setting it to a larger value
  will result in a larger FORTH.EXE file, and you may
  need to run EXE2BIN ( Chap 10, DOS 2.0 ) to get enough
  disk space.  Once you are satisfied with what you have,
  then by all means take that extra memory.

- Reading the section on batch files may speed up your
  developement.  See the example files that came with
  the Macro Assembler.

- Subscribe to FORTH Dimensions.  It is a valuable source
  of system and application ideas.  Talking with fellow
  FORTH programmers is sure to stir up some exciting ideas.
  Consider joining a FIG chapter.  See the back of FORTH
  Dimensions for more info.

- <Ctrl-Break> will vector to WARM start ( Label WRM: )

%endif

; Define the entry point, not valid for auto booting.
        ;     ORIG


























